/* moonshot-add-dialog.c generated by valac 0.10.4, the Vala compiler
 * generated from moonshot-add-dialog.vala, do not modify */

/*
 * Copyright (c) 2011-2014, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <atk/atk.h>


#define TYPE_ADD_IDENTITY_DIALOG (add_identity_dialog_get_type ())
#define ADD_IDENTITY_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADD_IDENTITY_DIALOG, AddIdentityDialog))
#define ADD_IDENTITY_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADD_IDENTITY_DIALOG, AddIdentityDialogClass))
#define IS_ADD_IDENTITY_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADD_IDENTITY_DIALOG))
#define IS_ADD_IDENTITY_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADD_IDENTITY_DIALOG))
#define ADD_IDENTITY_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADD_IDENTITY_DIALOG, AddIdentityDialogClass))

typedef struct _AddIdentityDialog AddIdentityDialog;
typedef struct _AddIdentityDialogClass AddIdentityDialogClass;
typedef struct _AddIdentityDialogPrivate AddIdentityDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _AddIdentityDialog {
	GtkDialog parent_instance;
	AddIdentityDialogPrivate * priv;
	gboolean complete;
};

struct _AddIdentityDialogClass {
	GtkDialogClass parent_class;
};

struct _AddIdentityDialogPrivate {
	GtkEntry* displayname_entry;
	GtkLabel* displayname_label;
	GtkEntry* issuer_entry;
	GtkLabel* issuer_label;
	GtkEntry* username_entry;
	GtkLabel* username_label;
	GtkEntry* password_entry;
	GtkLabel* password_label;
	GtkCheckButton* remember_checkbutton;
	GtkLabel* message_label;
};


static gpointer add_identity_dialog_parent_class = NULL;

GType add_identity_dialog_get_type (void) G_GNUC_CONST;
#define ADD_IDENTITY_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ADD_IDENTITY_DIALOG, AddIdentityDialogPrivate))
enum  {
	ADD_IDENTITY_DIALOG_DUMMY_PROPERTY,
	ADD_IDENTITY_DIALOG_DISPLAY_NAME,
	ADD_IDENTITY_DIALOG_ISSUER,
	ADD_IDENTITY_DIALOG_USERNAME,
	ADD_IDENTITY_DIALOG_PASSWORD,
	ADD_IDENTITY_DIALOG_STORE_PASSWORD
};
#define ADD_IDENTITY_DIALOG_displayname_labeltext _ ("Display Name")
#define ADD_IDENTITY_DIALOG_issuer_labeltext _ ("Issuer")
#define ADD_IDENTITY_DIALOG_username_labeltext _ ("Username")
#define ADD_IDENTITY_DIALOG_password_labeltext _ ("Password")
AddIdentityDialog* add_identity_dialog_new (void);
AddIdentityDialog* add_identity_dialog_construct (GType object_type);
static void add_identity_dialog_set_atk_relation (AddIdentityDialog* self, GtkWidget* widget, GtkWidget* target_widget, AtkRelationType relationship);
static void add_identity_dialog_on_response (AddIdentityDialog* self, GtkDialog* source, gint response_id);
static void _add_identity_dialog_on_response_gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);
static char* add_identity_dialog_update_preamble (const char* preamble);
static char* add_identity_dialog_update_message (const char* old_message, const char* new_item);
static void add_identity_dialog_check_field (const char* field, GtkLabel* label, const char* fieldname, char** preamble, char** message);
static gboolean add_identity_dialog_check_fields (AddIdentityDialog* self);
gboolean add_identity_dialog_get_store_password (AddIdentityDialog* self);
const char* add_identity_dialog_get_password (AddIdentityDialog* self);
const char* add_identity_dialog_get_display_name (AddIdentityDialog* self);
const char* add_identity_dialog_get_issuer (AddIdentityDialog* self);
const char* add_identity_dialog_get_username (AddIdentityDialog* self);
static void add_identity_dialog_finalize (GObject* obj);
static void add_identity_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 1212 "glib-2.0.vapi"
static const char* string_to_string (const char* self) {
#line 128 "moonshot-add-dialog.c"
	const char* result = NULL;
#line 1212 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "moonshot-add-dialog.c"
	result = self;
#line 1213 "glib-2.0.vapi"
	return result;
#line 136 "moonshot-add-dialog.c"
}


#line 182 "moonshot-add-dialog.vala"
static void _add_identity_dialog_on_response_gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
#line 142 "moonshot-add-dialog.c"
	add_identity_dialog_on_response (self, _sender, response_id);
}


#line 72 "moonshot-add-dialog.vala"
AddIdentityDialog* add_identity_dialog_construct (GType object_type) {
#line 149 "moonshot-add-dialog.c"
	AddIdentityDialog * self;
	GtkWidget* content_area;
	char* _tmp0_;
	GtkLabel* _tmp1_;
	GtkEntry* _tmp2_;
	char* _tmp3_;
	GtkLabel* _tmp4_;
	GtkEntry* _tmp5_;
	char* _tmp6_;
	GtkLabel* _tmp7_;
	GtkEntry* _tmp8_;
	char* _tmp9_;
	GtkLabel* _tmp10_;
	GtkEntry* _tmp11_;
	GtkCheckButton* _tmp12_;
	GtkLabel* _tmp13_;
	GtkTable* table;
	GtkVBox* vbox;
	self = g_object_newv (object_type, 0, NULL);
#line 74 "moonshot-add-dialog.vala"
	gtk_window_set_title ((GtkWindow*) self, _ ("Add ID Card"));
#line 75 "moonshot-add-dialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 77 "moonshot-add-dialog.vala"
	gtk_dialog_add_buttons ((GtkDialog*) self, _ ("Add ID Card"), GTK_RESPONSE_OK, GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, NULL);
#line 84 "moonshot-add-dialog.vala"
	content_area = _g_object_ref0 (gtk_dialog_get_content_area ((GtkDialog*) self));
#line 85 "moonshot-add-dialog.vala"
	gtk_box_set_spacing (GTK_BOX (content_area), 12);
#line 87 "moonshot-add-dialog.vala"
	self->priv->displayname_label = (_tmp1_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_tmp0_ = g_strconcat (string_to_string (ADD_IDENTITY_DIALOG_displayname_labeltext), ":", NULL))), _g_object_unref0 (self->priv->displayname_label), _tmp1_);
#line 181 "moonshot-add-dialog.c"
	_g_free0 (_tmp0_);
#line 88 "moonshot-add-dialog.vala"
	gtk_misc_set_alignment ((GtkMisc*) self->priv->displayname_label, (float) 1, (float) 0.5);
#line 89 "moonshot-add-dialog.vala"
	self->priv->displayname_entry = (_tmp2_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->displayname_entry), _tmp2_);
#line 90 "moonshot-add-dialog.vala"
	self->priv->issuer_label = (_tmp4_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_tmp3_ = g_strconcat (string_to_string (ADD_IDENTITY_DIALOG_issuer_labeltext), ":", NULL))), _g_object_unref0 (self->priv->issuer_label), _tmp4_);
#line 189 "moonshot-add-dialog.c"
	_g_free0 (_tmp3_);
#line 91 "moonshot-add-dialog.vala"
	gtk_misc_set_alignment ((GtkMisc*) self->priv->issuer_label, (float) 1, (float) 0.5);
#line 92 "moonshot-add-dialog.vala"
	self->priv->issuer_entry = (_tmp5_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->issuer_entry), _tmp5_);
#line 93 "moonshot-add-dialog.vala"
	self->priv->username_label = (_tmp7_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_tmp6_ = g_strconcat (string_to_string (ADD_IDENTITY_DIALOG_username_labeltext), ":", NULL))), _g_object_unref0 (self->priv->username_label), _tmp7_);
#line 197 "moonshot-add-dialog.c"
	_g_free0 (_tmp6_);
#line 94 "moonshot-add-dialog.vala"
	gtk_misc_set_alignment ((GtkMisc*) self->priv->username_label, (float) 1, (float) 0.5);
#line 95 "moonshot-add-dialog.vala"
	self->priv->username_entry = (_tmp8_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->username_entry), _tmp8_);
#line 96 "moonshot-add-dialog.vala"
	self->priv->password_label = (_tmp10_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (_tmp9_ = g_strconcat (string_to_string (ADD_IDENTITY_DIALOG_password_labeltext), ":", NULL))), _g_object_unref0 (self->priv->password_label), _tmp10_);
#line 205 "moonshot-add-dialog.c"
	_g_free0 (_tmp9_);
#line 97 "moonshot-add-dialog.vala"
	gtk_misc_set_alignment ((GtkMisc*) self->priv->password_label, (float) 1, (float) 0.5);
#line 98 "moonshot-add-dialog.vala"
	self->priv->password_entry = (_tmp11_ = g_object_ref_sink ((GtkEntry*) gtk_entry_new ()), _g_object_unref0 (self->priv->password_entry), _tmp11_);
#line 99 "moonshot-add-dialog.vala"
	gtk_entry_set_invisible_char (self->priv->password_entry, (gunichar) '*');
#line 100 "moonshot-add-dialog.vala"
	gtk_entry_set_visibility (self->priv->password_entry, FALSE);
#line 101 "moonshot-add-dialog.vala"
	self->priv->remember_checkbutton = (_tmp12_ = g_object_ref_sink ((GtkCheckButton*) gtk_check_button_new_with_label (_ ("Remember password"))), _g_object_unref0 (self->priv->remember_checkbutton), _tmp12_);
#line 102 "moonshot-add-dialog.vala"
	self->priv->message_label = (_tmp13_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), _g_object_unref0 (self->priv->message_label), _tmp13_);
#line 103 "moonshot-add-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) self->priv->message_label, FALSE);
#line 105 "moonshot-add-dialog.vala"
	add_identity_dialog_set_atk_relation (self, (GtkWidget*) self->priv->displayname_label, (GtkWidget*) self->priv->displayname_entry, ATK_RELATION_LABEL_FOR);
#line 106 "moonshot-add-dialog.vala"
	add_identity_dialog_set_atk_relation (self, (GtkWidget*) self->priv->issuer_label, (GtkWidget*) self->priv->issuer_entry, ATK_RELATION_LABEL_FOR);
#line 107 "moonshot-add-dialog.vala"
	add_identity_dialog_set_atk_relation (self, (GtkWidget*) self->priv->username_label, (GtkWidget*) self->priv->username_entry, ATK_RELATION_LABEL_FOR);
#line 108 "moonshot-add-dialog.vala"
	add_identity_dialog_set_atk_relation (self, (GtkWidget*) self->priv->password_entry, (GtkWidget*) self->priv->password_entry, ATK_RELATION_LABEL_FOR);
#line 110 "moonshot-add-dialog.vala"
	table = g_object_ref_sink ((GtkTable*) gtk_table_new ((guint) 6, (guint) 2, FALSE));
#line 111 "moonshot-add-dialog.vala"
	gtk_table_set_col_spacings (table, (guint) 10);
#line 112 "moonshot-add-dialog.vala"
	gtk_table_set_row_spacings (table, (guint) 10);
#line 114 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->message_label, (guint) 0, (guint) 2, (guint) 0, (guint) 1);
#line 115 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->displayname_label, (guint) 0, (guint) 1, (guint) 1, (guint) 2);
#line 116 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->displayname_entry, (guint) 1, (guint) 2, (guint) 1, (guint) 2);
#line 117 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->issuer_label, (guint) 0, (guint) 1, (guint) 2, (guint) 3);
#line 118 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->issuer_entry, (guint) 1, (guint) 2, (guint) 2, (guint) 3);
#line 119 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->username_label, (guint) 0, (guint) 1, (guint) 3, (guint) 4);
#line 120 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->username_entry, (guint) 1, (guint) 2, (guint) 3, (guint) 4);
#line 121 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->password_label, (guint) 0, (guint) 1, (guint) 4, (guint) 5);
#line 122 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->password_entry, (guint) 1, (guint) 2, (guint) 4, (guint) 5);
#line 123 "moonshot-add-dialog.vala"
	gtk_table_attach_defaults (table, (GtkWidget*) self->priv->remember_checkbutton, (guint) 1, (guint) 2, (guint) 5, (guint) 6);
#line 125 "moonshot-add-dialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) _add_identity_dialog_on_response_gtk_dialog_response, self, 0);
#line 126 "moonshot-add-dialog.vala"
	vbox = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 0));
#line 127 "moonshot-add-dialog.vala"
	gtk_container_set_border_width ((GtkContainer*) vbox, (guint) 6);
#line 128 "moonshot-add-dialog.vala"
	gtk_box_pack_start ((GtkBox*) vbox, (GtkWidget*) table, FALSE, FALSE, (guint) 0);
#line 130 "moonshot-add-dialog.vala"
	gtk_container_add (GTK_CONTAINER (content_area), (GtkWidget*) vbox);
#line 132 "moonshot-add-dialog.vala"
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 6);
#line 133 "moonshot-add-dialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 134 "moonshot-add-dialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 271 "moonshot-add-dialog.c"
	_g_object_unref0 (vbox);
	_g_object_unref0 (table);
	_g_object_unref0 (content_area);
	return self;
}


#line 72 "moonshot-add-dialog.vala"
AddIdentityDialog* add_identity_dialog_new (void) {
#line 72 "moonshot-add-dialog.vala"
	return add_identity_dialog_construct (TYPE_ADD_IDENTITY_DIALOG);
#line 283 "moonshot-add-dialog.c"
}


#line 137 "moonshot-add-dialog.vala"
static char* add_identity_dialog_update_preamble (const char* preamble) {
#line 289 "moonshot-add-dialog.c"
	char* result = NULL;
#line 137 "moonshot-add-dialog.vala"
	g_return_val_if_fail (preamble != NULL, NULL);
#line 139 "moonshot-add-dialog.vala"
	if (_vala_strcmp0 (preamble, "") == 0) {
#line 295 "moonshot-add-dialog.c"
		result = g_strdup (_ ("Missing required field: "));
#line 140 "moonshot-add-dialog.vala"
		return result;
#line 299 "moonshot-add-dialog.c"
	}
	result = g_strdup (_ ("Missing required fields: "));
#line 141 "moonshot-add-dialog.vala"
	return result;
#line 304 "moonshot-add-dialog.c"
}


#line 144 "moonshot-add-dialog.vala"
static char* add_identity_dialog_update_message (const char* old_message, const char* new_item) {
#line 310 "moonshot-add-dialog.c"
	char* result = NULL;
	char* message;
#line 144 "moonshot-add-dialog.vala"
	g_return_val_if_fail (old_message != NULL, NULL);
#line 144 "moonshot-add-dialog.vala"
	g_return_val_if_fail (new_item != NULL, NULL);
#line 317 "moonshot-add-dialog.c"
	message = NULL;
#line 147 "moonshot-add-dialog.vala"
	if (_vala_strcmp0 (old_message, "") == 0) {
#line 321 "moonshot-add-dialog.c"
		char* _tmp0_;
#line 148 "moonshot-add-dialog.vala"
		message = (_tmp0_ = g_strdup (new_item), _g_free0 (message), _tmp0_);
#line 325 "moonshot-add-dialog.c"
	} else {
		char* _tmp1_;
		char* _tmp2_;
#line 150 "moonshot-add-dialog.vala"
		message = (_tmp2_ = g_strconcat (_tmp1_ = g_strconcat (old_message, ", ", NULL), new_item, NULL), _g_free0 (message), _tmp2_);
#line 331 "moonshot-add-dialog.c"
		_g_free0 (_tmp1_);
	}
	result = message;
#line 151 "moonshot-add-dialog.vala"
	return result;
#line 337 "moonshot-add-dialog.c"
}


#line 154 "moonshot-add-dialog.vala"
static void add_identity_dialog_check_field (const char* field, GtkLabel* label, const char* fieldname, char** preamble, char** message) {
#line 343 "moonshot-add-dialog.c"
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
#line 154 "moonshot-add-dialog.vala"
	g_return_if_fail (field != NULL);
#line 154 "moonshot-add-dialog.vala"
	g_return_if_fail (label != NULL);
#line 154 "moonshot-add-dialog.vala"
	g_return_if_fail (fieldname != NULL);
#line 154 "moonshot-add-dialog.vala"
	g_return_if_fail (preamble != NULL);
#line 154 "moonshot-add-dialog.vala"
	g_return_if_fail (message != NULL);
#line 156 "moonshot-add-dialog.vala"
	if (_vala_strcmp0 (field, "") != 0) {
#line 359 "moonshot-add-dialog.c"
		char* _tmp0_;
#line 157 "moonshot-add-dialog.vala"
		gtk_label_set_markup (label, _tmp0_ = g_strconcat (string_to_string (fieldname), ":", NULL));
#line 363 "moonshot-add-dialog.c"
		_g_free0 (_tmp0_);
#line 158 "moonshot-add-dialog.vala"
		return;
#line 367 "moonshot-add-dialog.c"
	}
#line 160 "moonshot-add-dialog.vala"
	gtk_label_set_markup (label, _tmp1_ = g_strconcat ("<span foreground=\"red\">", string_to_string (fieldname), ":</span>", NULL));
#line 371 "moonshot-add-dialog.c"
	_g_free0 (_tmp1_);
#line 161 "moonshot-add-dialog.vala"
	*preamble = (_tmp2_ = add_identity_dialog_update_preamble (*preamble), _g_free0 (*preamble), _tmp2_);
#line 162 "moonshot-add-dialog.vala"
	*message = (_tmp3_ = add_identity_dialog_update_message (*message, fieldname), _g_free0 (*message), _tmp3_);
#line 377 "moonshot-add-dialog.c"
}


#line 165 "moonshot-add-dialog.vala"
static gboolean add_identity_dialog_check_fields (AddIdentityDialog* self) {
#line 383 "moonshot-add-dialog.c"
	gboolean result = FALSE;
	char* preamble;
	char* message;
	const char* _tmp0_;
	char* password_test;
#line 165 "moonshot-add-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 167 "moonshot-add-dialog.vala"
	preamble = g_strdup ("");
#line 168 "moonshot-add-dialog.vala"
	message = g_strdup ("");
#line 395 "moonshot-add-dialog.c"
	_tmp0_ = NULL;
#line 169 "moonshot-add-dialog.vala"
	if (add_identity_dialog_get_store_password (self)) {
#line 169 "moonshot-add-dialog.vala"
		_tmp0_ = add_identity_dialog_get_password (self);
#line 401 "moonshot-add-dialog.c"
	} else {
#line 169 "moonshot-add-dialog.vala"
		_tmp0_ = "not required";
#line 405 "moonshot-add-dialog.c"
	}
#line 169 "moonshot-add-dialog.vala"
	password_test = g_strdup (_tmp0_);
#line 170 "moonshot-add-dialog.vala"
	add_identity_dialog_check_field (add_identity_dialog_get_display_name (self), self->priv->displayname_label, ADD_IDENTITY_DIALOG_displayname_labeltext, &preamble, &message);
#line 171 "moonshot-add-dialog.vala"
	add_identity_dialog_check_field (add_identity_dialog_get_issuer (self), self->priv->issuer_label, ADD_IDENTITY_DIALOG_issuer_labeltext, &preamble, &message);
#line 172 "moonshot-add-dialog.vala"
	add_identity_dialog_check_field (add_identity_dialog_get_username (self), self->priv->username_label, ADD_IDENTITY_DIALOG_username_labeltext, &preamble, &message);
#line 173 "moonshot-add-dialog.vala"
	add_identity_dialog_check_field (password_test, self->priv->password_label, ADD_IDENTITY_DIALOG_password_labeltext, &preamble, &message);
#line 174 "moonshot-add-dialog.vala"
	if (_vala_strcmp0 (message, "") != 0) {
#line 419 "moonshot-add-dialog.c"
		char* _tmp1_;
#line 175 "moonshot-add-dialog.vala"
		gtk_widget_set_visible ((GtkWidget*) self->priv->message_label, TRUE);
#line 176 "moonshot-add-dialog.vala"
		gtk_label_set_markup (self->priv->message_label, _tmp1_ = g_strconcat ("<span foreground=\"red\">", string_to_string (preamble), string_to_string (message), "</span>", NULL));
#line 425 "moonshot-add-dialog.c"
		_g_free0 (_tmp1_);
		result = FALSE;
		_g_free0 (password_test);
		_g_free0 (message);
		_g_free0 (preamble);
#line 177 "moonshot-add-dialog.vala"
		return result;
#line 433 "moonshot-add-dialog.c"
	}
	result = TRUE;
	_g_free0 (password_test);
	_g_free0 (message);
	_g_free0 (preamble);
#line 179 "moonshot-add-dialog.vala"
	return result;
#line 441 "moonshot-add-dialog.c"
}


#line 182 "moonshot-add-dialog.vala"
static void add_identity_dialog_on_response (AddIdentityDialog* self, GtkDialog* source, gint response_id) {
#line 182 "moonshot-add-dialog.vala"
	g_return_if_fail (self != NULL);
#line 182 "moonshot-add-dialog.vala"
	g_return_if_fail (source != NULL);
#line 184 "moonshot-add-dialog.vala"
	switch (response_id) {
#line 453 "moonshot-add-dialog.c"
		case GTK_RESPONSE_OK:
		{
#line 186 "moonshot-add-dialog.vala"
			self->complete = add_identity_dialog_check_fields (self);
#line 187 "moonshot-add-dialog.vala"
			break;
#line 460 "moonshot-add-dialog.c"
		}
		case GTK_RESPONSE_CANCEL:
		{
#line 189 "moonshot-add-dialog.vala"
			self->complete = TRUE;
#line 190 "moonshot-add-dialog.vala"
			break;
#line 468 "moonshot-add-dialog.c"
		}
	}
}


#line 194 "moonshot-add-dialog.vala"
static void add_identity_dialog_set_atk_relation (AddIdentityDialog* self, GtkWidget* widget, GtkWidget* target_widget, AtkRelationType relationship) {
#line 476 "moonshot-add-dialog.c"
	AtkObject* atk_widget;
	AtkObject* atk_target_widget;
#line 194 "moonshot-add-dialog.vala"
	g_return_if_fail (self != NULL);
#line 194 "moonshot-add-dialog.vala"
	g_return_if_fail (widget != NULL);
#line 194 "moonshot-add-dialog.vala"
	g_return_if_fail (target_widget != NULL);
#line 196 "moonshot-add-dialog.vala"
	atk_widget = _g_object_ref0 (gtk_widget_get_accessible (widget));
#line 197 "moonshot-add-dialog.vala"
	atk_target_widget = _g_object_ref0 (gtk_widget_get_accessible (target_widget));
#line 199 "moonshot-add-dialog.vala"
	atk_object_add_relationship (atk_widget, relationship, atk_target_widget);
#line 491 "moonshot-add-dialog.c"
	_g_object_unref0 (atk_target_widget);
	_g_object_unref0 (atk_widget);
}


const char* add_identity_dialog_get_display_name (AddIdentityDialog* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = gtk_entry_get_text (self->priv->displayname_entry);
#line 53 "moonshot-add-dialog.vala"
	return result;
#line 503 "moonshot-add-dialog.c"
}


const char* add_identity_dialog_get_issuer (AddIdentityDialog* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = gtk_entry_get_text (self->priv->issuer_entry);
#line 57 "moonshot-add-dialog.vala"
	return result;
#line 513 "moonshot-add-dialog.c"
}


const char* add_identity_dialog_get_username (AddIdentityDialog* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = gtk_entry_get_text (self->priv->username_entry);
#line 61 "moonshot-add-dialog.vala"
	return result;
#line 523 "moonshot-add-dialog.c"
}


const char* add_identity_dialog_get_password (AddIdentityDialog* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = gtk_entry_get_text (self->priv->password_entry);
#line 65 "moonshot-add-dialog.vala"
	return result;
#line 533 "moonshot-add-dialog.c"
}


gboolean add_identity_dialog_get_store_password (AddIdentityDialog* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = gtk_toggle_button_get_active ((GtkToggleButton*) self->priv->remember_checkbutton);
#line 69 "moonshot-add-dialog.vala"
	return result;
#line 543 "moonshot-add-dialog.c"
}


static void add_identity_dialog_class_init (AddIdentityDialogClass * klass) {
	add_identity_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (AddIdentityDialogPrivate));
	G_OBJECT_CLASS (klass)->get_property = add_identity_dialog_get_property;
	G_OBJECT_CLASS (klass)->finalize = add_identity_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_IDENTITY_DIALOG_DISPLAY_NAME, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_IDENTITY_DIALOG_ISSUER, g_param_spec_string ("issuer", "issuer", "issuer", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_IDENTITY_DIALOG_USERNAME, g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_IDENTITY_DIALOG_PASSWORD, g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_IDENTITY_DIALOG_STORE_PASSWORD, g_param_spec_boolean ("store-password", "store-password", "store-password", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void add_identity_dialog_instance_init (AddIdentityDialog * self) {
	self->priv = ADD_IDENTITY_DIALOG_GET_PRIVATE (self);
}


static void add_identity_dialog_finalize (GObject* obj) {
	AddIdentityDialog * self;
	self = ADD_IDENTITY_DIALOG (obj);
	_g_object_unref0 (self->priv->displayname_entry);
	_g_object_unref0 (self->priv->displayname_label);
	_g_object_unref0 (self->priv->issuer_entry);
	_g_object_unref0 (self->priv->issuer_label);
	_g_object_unref0 (self->priv->username_entry);
	_g_object_unref0 (self->priv->username_label);
	_g_object_unref0 (self->priv->password_entry);
	_g_object_unref0 (self->priv->password_label);
	_g_object_unref0 (self->priv->remember_checkbutton);
	_g_object_unref0 (self->priv->message_label);
	G_OBJECT_CLASS (add_identity_dialog_parent_class)->finalize (obj);
}


GType add_identity_dialog_get_type (void) {
	static volatile gsize add_identity_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&add_identity_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AddIdentityDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) add_identity_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AddIdentityDialog), 0, (GInstanceInitFunc) add_identity_dialog_instance_init, NULL };
		GType add_identity_dialog_type_id;
		add_identity_dialog_type_id = g_type_register_static (GTK_TYPE_DIALOG, "AddIdentityDialog", &g_define_type_info, 0);
		g_once_init_leave (&add_identity_dialog_type_id__volatile, add_identity_dialog_type_id);
	}
	return add_identity_dialog_type_id__volatile;
}


static void add_identity_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AddIdentityDialog * self;
	self = ADD_IDENTITY_DIALOG (object);
	switch (property_id) {
		case ADD_IDENTITY_DIALOG_DISPLAY_NAME:
		g_value_set_string (value, add_identity_dialog_get_display_name (self));
		break;
		case ADD_IDENTITY_DIALOG_ISSUER:
		g_value_set_string (value, add_identity_dialog_get_issuer (self));
		break;
		case ADD_IDENTITY_DIALOG_USERNAME:
		g_value_set_string (value, add_identity_dialog_get_username (self));
		break;
		case ADD_IDENTITY_DIALOG_PASSWORD:
		g_value_set_string (value, add_identity_dialog_get_password (self));
		break;
		case ADD_IDENTITY_DIALOG_STORE_PASSWORD:
		g_value_set_boolean (value, add_identity_dialog_get_store_password (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




