/* moonshot-id.c generated by valac 0.10.4, the Vala compiler
 * generated from moonshot-id.vala, do not modify */

/*
 * Copyright (c) 2011-2014, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gnome-keyring-memory.h>


#define TYPE_TRUST_ANCHOR (trust_anchor_get_type ())
#define TRUST_ANCHOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRUST_ANCHOR, TrustAnchor))
#define TRUST_ANCHOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRUST_ANCHOR, TrustAnchorClass))
#define IS_TRUST_ANCHOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRUST_ANCHOR))
#define IS_TRUST_ANCHOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRUST_ANCHOR))
#define TRUST_ANCHOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRUST_ANCHOR, TrustAnchorClass))

typedef struct _TrustAnchor TrustAnchor;
typedef struct _TrustAnchorClass TrustAnchorClass;
typedef struct _TrustAnchorPrivate TrustAnchorPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_RULE (rule_get_type ())
typedef struct _Rule Rule;

#define TYPE_ID_CARD (id_card_get_type ())
#define ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD, IdCard))
#define ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD, IdCardClass))
#define IS_ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD))
#define IS_ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD))
#define ID_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD, IdCardClass))

typedef struct _IdCard IdCard;
typedef struct _IdCardClass IdCardClass;
typedef struct _IdCardPrivate IdCardPrivate;

#define ID_CARD_TYPE_DIFF_FLAGS (id_card_diff_flags_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _TrustAnchor {
	GObject parent_instance;
	TrustAnchorPrivate * priv;
};

struct _TrustAnchorClass {
	GObjectClass parent_class;
};

struct _TrustAnchorPrivate {
	char* _ca_cert;
	char* _subject;
	char* _subject_alt;
	char* _server_cert;
};

struct _Rule {
	char* pattern;
	char* always_confirm;
};

struct _IdCard {
	GObject parent_instance;
	IdCardPrivate * priv;
};

struct _IdCardClass {
	GObjectClass parent_class;
};

struct _IdCardPrivate {
	char* _nai;
	char* _display_name;
	char* _username;
	const char* _password;
	char* _issuer;
	Rule* _rules;
	gint _rules_length1;
	gint __rules_size_;
	char** _services;
	gint _services_length1;
	gint __services_size_;
	gboolean _temporary;
	TrustAnchor* _trust_anchor;
	gboolean _store_password;
};

typedef enum  {
	ID_CARD_DIFF_FLAGS_DISPLAY_NAME,
	ID_CARD_DIFF_FLAGS_USERNAME,
	ID_CARD_DIFF_FLAGS_PASSWORD,
	ID_CARD_DIFF_FLAGS_ISSUER,
	ID_CARD_DIFF_FLAGS_RULES,
	ID_CARD_DIFF_FLAGS_SERVICES,
	ID_CARD_DIFF_FLAGS_TRUST_ANCHOR
} IdCardDiffFlags;


static gpointer trust_anchor_parent_class = NULL;
static gpointer id_card_parent_class = NULL;

GType trust_anchor_get_type (void) G_GNUC_CONST;
#define TRUST_ANCHOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TRUST_ANCHOR, TrustAnchorPrivate))
enum  {
	TRUST_ANCHOR_DUMMY_PROPERTY,
	TRUST_ANCHOR_CA_CERT,
	TRUST_ANCHOR_SUBJECT,
	TRUST_ANCHOR_SUBJECT_ALT,
	TRUST_ANCHOR_SERVER_CERT
};
gint trust_anchor_Compare (TrustAnchor* self, TrustAnchor* other);
const char* trust_anchor_get_ca_cert (TrustAnchor* self);
const char* trust_anchor_get_subject (TrustAnchor* self);
const char* trust_anchor_get_subject_alt (TrustAnchor* self);
const char* trust_anchor_get_server_cert (TrustAnchor* self);
TrustAnchor* trust_anchor_new (void);
TrustAnchor* trust_anchor_construct (GType object_type);
void trust_anchor_set_ca_cert (TrustAnchor* self, const char* value);
void trust_anchor_set_subject (TrustAnchor* self, const char* value);
void trust_anchor_set_subject_alt (TrustAnchor* self, const char* value);
void trust_anchor_set_server_cert (TrustAnchor* self, const char* value);
static void trust_anchor_finalize (GObject* obj);
static void trust_anchor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void trust_anchor_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType rule_get_type (void) G_GNUC_CONST;
Rule* rule_dup (const Rule* self);
void rule_free (Rule* self);
void rule_copy (const Rule* self, Rule* dest);
void rule_destroy (Rule* self);
gint rule_Compare (Rule *self, Rule* other);
GType id_card_get_type (void) G_GNUC_CONST;
#define ID_CARD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ID_CARD, IdCardPrivate))
enum  {
	ID_CARD_DUMMY_PROPERTY,
	ID_CARD_DISPLAY_NAME,
	ID_CARD_USERNAME,
	ID_CARD_PASSWORD,
	ID_CARD_ISSUER,
	ID_CARD_SERVICES,
	ID_CARD_TEMPORARY,
	ID_CARD_TRUST_ANCHOR,
	ID_CARD_NAI,
	ID_CARD_STORE_PASSWORD
};
GType id_card_diff_flags_get_type (void) G_GNUC_CONST;
static void _vala_Rule_array_free (Rule* array, gint array_length);
#define ID_CARD_NO_IDENTITY "No Identity"
gboolean id_card_IsNoIdentity (IdCard* self);
const char* id_card_get_display_name (IdCard* self);
gint id_card_Compare (IdCard* self, IdCard* other);
const char* id_card_get_username (IdCard* self);
const char* id_card_get_password (IdCard* self);
const char* id_card_get_issuer (IdCard* self);
gint CompareRules (Rule* a, int a_length1, Rule* b, int b_length1);
Rule* id_card_get_rules (IdCard* self, int* result_length1);
gint CompareStringArray (char** a, int a_length1, char** b, int b_length1);
char** id_card_get_services (IdCard* self, int* result_length1);
TrustAnchor* id_card_get_trust_anchor (IdCard* self);
IdCard* id_card_NewNoIdentity (void);
IdCard* id_card_new (void);
IdCard* id_card_construct (GType object_type);
void id_card_set_display_name (IdCard* self, const char* value);
void id_card_set_username (IdCard* self, const char* value);
void id_card_set_password (IdCard* self, const char* value);
void id_card_set_issuer (IdCard* self, const char* value);
void id_card_set_rules (IdCard* self, Rule* value, int value_length1);
static Rule* _vala_array_dup8 (Rule* self, int length);
void id_card_set_services (IdCard* self, char** value, int value_length1);
static char** _vala_array_dup9 (char** self, int length);
gboolean id_card_get_temporary (IdCard* self);
void id_card_set_temporary (IdCard* self, gboolean value);
void id_card_set_trust_anchor (IdCard* self, TrustAnchor* value);
const char* id_card_get_nai (IdCard* self);
gboolean id_card_get_store_password (IdCard* self);
void id_card_set_store_password (IdCard* self, gboolean value);
static void id_card_finalize (GObject* obj);
static void id_card_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void id_card_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 38 "moonshot-id.vala"
gint trust_anchor_Compare (TrustAnchor* self, TrustAnchor* other) {
#line 220 "moonshot-id.c"
	gint result = 0;
#line 38 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "moonshot-id.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 40 "moonshot-id.vala"
	if (_vala_strcmp0 (self->priv->_ca_cert, other->priv->_ca_cert) != 0) {
#line 228 "moonshot-id.c"
		result = 1;
#line 41 "moonshot-id.vala"
		return result;
#line 232 "moonshot-id.c"
	}
#line 42 "moonshot-id.vala"
	if (_vala_strcmp0 (self->priv->_subject, other->priv->_subject) != 0) {
#line 236 "moonshot-id.c"
		result = 1;
#line 43 "moonshot-id.vala"
		return result;
#line 240 "moonshot-id.c"
	}
#line 44 "moonshot-id.vala"
	if (_vala_strcmp0 (self->priv->_subject_alt, other->priv->_subject_alt) != 0) {
#line 244 "moonshot-id.c"
		result = 1;
#line 45 "moonshot-id.vala"
		return result;
#line 248 "moonshot-id.c"
	}
#line 46 "moonshot-id.vala"
	if (_vala_strcmp0 (self->priv->_server_cert, other->priv->_server_cert) != 0) {
#line 252 "moonshot-id.c"
		result = 1;
#line 47 "moonshot-id.vala"
		return result;
#line 256 "moonshot-id.c"
	}
	result = 0;
#line 48 "moonshot-id.vala"
	return result;
#line 261 "moonshot-id.c"
}


#line 32 "moonshot-id.vala"
TrustAnchor* trust_anchor_construct (GType object_type) {
#line 267 "moonshot-id.c"
	TrustAnchor * self = NULL;
#line 32 "moonshot-id.vala"
	self = (TrustAnchor*) g_object_new (object_type, NULL);
#line 271 "moonshot-id.c"
	return self;
}


#line 32 "moonshot-id.vala"
TrustAnchor* trust_anchor_new (void) {
#line 32 "moonshot-id.vala"
	return trust_anchor_construct (TYPE_TRUST_ANCHOR);
#line 280 "moonshot-id.c"
}


const char* trust_anchor_get_ca_cert (TrustAnchor* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_ca_cert;
#line 34 "moonshot-id.vala"
	return result;
#line 290 "moonshot-id.c"
}


void trust_anchor_set_ca_cert (TrustAnchor* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_ca_cert = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_ca_cert), _tmp0_);
	g_object_notify ((GObject *) self, "ca-cert");
}


const char* trust_anchor_get_subject (TrustAnchor* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_subject;
#line 35 "moonshot-id.vala"
	return result;
#line 308 "moonshot-id.c"
}


void trust_anchor_set_subject (TrustAnchor* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_subject = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_subject), _tmp0_);
	g_object_notify ((GObject *) self, "subject");
}


const char* trust_anchor_get_subject_alt (TrustAnchor* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_subject_alt;
#line 36 "moonshot-id.vala"
	return result;
#line 326 "moonshot-id.c"
}


void trust_anchor_set_subject_alt (TrustAnchor* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_subject_alt = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_subject_alt), _tmp0_);
	g_object_notify ((GObject *) self, "subject-alt");
}


const char* trust_anchor_get_server_cert (TrustAnchor* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_server_cert;
#line 37 "moonshot-id.vala"
	return result;
#line 344 "moonshot-id.c"
}


void trust_anchor_set_server_cert (TrustAnchor* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_server_cert = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_server_cert), _tmp0_);
	g_object_notify ((GObject *) self, "server-cert");
}


static void trust_anchor_class_init (TrustAnchorClass * klass) {
	trust_anchor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (TrustAnchorPrivate));
	G_OBJECT_CLASS (klass)->get_property = trust_anchor_get_property;
	G_OBJECT_CLASS (klass)->set_property = trust_anchor_set_property;
	G_OBJECT_CLASS (klass)->finalize = trust_anchor_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRUST_ANCHOR_CA_CERT, g_param_spec_string ("ca-cert", "ca-cert", "ca-cert", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRUST_ANCHOR_SUBJECT, g_param_spec_string ("subject", "subject", "subject", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRUST_ANCHOR_SUBJECT_ALT, g_param_spec_string ("subject-alt", "subject-alt", "subject-alt", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), TRUST_ANCHOR_SERVER_CERT, g_param_spec_string ("server-cert", "server-cert", "server-cert", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void trust_anchor_instance_init (TrustAnchor * self) {
	self->priv = TRUST_ANCHOR_GET_PRIVATE (self);
	self->priv->_ca_cert = g_strdup ("");
	self->priv->_subject = g_strdup ("");
	self->priv->_subject_alt = g_strdup ("");
	self->priv->_server_cert = g_strdup ("");
}


static void trust_anchor_finalize (GObject* obj) {
	TrustAnchor * self;
	self = TRUST_ANCHOR (obj);
	_g_free0 (self->priv->_ca_cert);
	_g_free0 (self->priv->_subject);
	_g_free0 (self->priv->_subject_alt);
	_g_free0 (self->priv->_server_cert);
	G_OBJECT_CLASS (trust_anchor_parent_class)->finalize (obj);
}


GType trust_anchor_get_type (void) {
	static volatile gsize trust_anchor_type_id__volatile = 0;
	if (g_once_init_enter (&trust_anchor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TrustAnchorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) trust_anchor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TrustAnchor), 0, (GInstanceInitFunc) trust_anchor_instance_init, NULL };
		GType trust_anchor_type_id;
		trust_anchor_type_id = g_type_register_static (G_TYPE_OBJECT, "TrustAnchor", &g_define_type_info, 0);
		g_once_init_leave (&trust_anchor_type_id__volatile, trust_anchor_type_id);
	}
	return trust_anchor_type_id__volatile;
}


static void trust_anchor_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TrustAnchor * self;
	self = TRUST_ANCHOR (object);
	switch (property_id) {
		case TRUST_ANCHOR_CA_CERT:
		g_value_set_string (value, trust_anchor_get_ca_cert (self));
		break;
		case TRUST_ANCHOR_SUBJECT:
		g_value_set_string (value, trust_anchor_get_subject (self));
		break;
		case TRUST_ANCHOR_SUBJECT_ALT:
		g_value_set_string (value, trust_anchor_get_subject_alt (self));
		break;
		case TRUST_ANCHOR_SERVER_CERT:
		g_value_set_string (value, trust_anchor_get_server_cert (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void trust_anchor_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TrustAnchor * self;
	self = TRUST_ANCHOR (object);
	switch (property_id) {
		case TRUST_ANCHOR_CA_CERT:
		trust_anchor_set_ca_cert (self, g_value_get_string (value));
		break;
		case TRUST_ANCHOR_SUBJECT:
		trust_anchor_set_subject (self, g_value_get_string (value));
		break;
		case TRUST_ANCHOR_SUBJECT_ALT:
		trust_anchor_set_subject_alt (self, g_value_get_string (value));
		break;
		case TRUST_ANCHOR_SERVER_CERT:
		trust_anchor_set_server_cert (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 56 "moonshot-id.vala"
gint rule_Compare (Rule *self, Rule* other) {
#line 449 "moonshot-id.c"
	gint result = 0;
#line 57 "moonshot-id.vala"
	if (_vala_strcmp0 ((*self).pattern, (*other).pattern) != 0) {
#line 453 "moonshot-id.c"
		result = 1;
#line 58 "moonshot-id.vala"
		return result;
#line 457 "moonshot-id.c"
	}
#line 59 "moonshot-id.vala"
	if (_vala_strcmp0 ((*self).always_confirm, (*other).always_confirm) != 0) {
#line 461 "moonshot-id.c"
		result = 1;
#line 60 "moonshot-id.vala"
		return result;
#line 465 "moonshot-id.c"
	}
	result = 0;
#line 61 "moonshot-id.vala"
	return result;
#line 470 "moonshot-id.c"
}


void rule_copy (const Rule* self, Rule* dest) {
	dest->pattern = g_strdup (self->pattern);
	dest->always_confirm = g_strdup (self->always_confirm);
}


void rule_destroy (Rule* self) {
	_g_free0 (self->pattern);
	_g_free0 (self->always_confirm);
}


Rule* rule_dup (const Rule* self) {
	Rule* dup;
	dup = g_new0 (Rule, 1);
	rule_copy (self, dup);
	return dup;
}


void rule_free (Rule* self) {
	rule_destroy (self);
	g_free (self);
}


GType rule_get_type (void) {
	static volatile gsize rule_type_id__volatile = 0;
	if (g_once_init_enter (&rule_type_id__volatile)) {
		GType rule_type_id;
		rule_type_id = g_boxed_type_register_static ("Rule", (GBoxedCopyFunc) rule_dup, (GBoxedFreeFunc) rule_free);
		g_once_init_leave (&rule_type_id__volatile, rule_type_id);
	}
	return rule_type_id__volatile;
}


GType id_card_diff_flags_get_type (void) {
	static volatile gsize id_card_diff_flags_type_id__volatile = 0;
	if (g_once_init_enter (&id_card_diff_flags_type_id__volatile)) {
		static const GEnumValue values[] = {{ID_CARD_DIFF_FLAGS_DISPLAY_NAME, "ID_CARD_DIFF_FLAGS_DISPLAY_NAME", "display-name"}, {ID_CARD_DIFF_FLAGS_USERNAME, "ID_CARD_DIFF_FLAGS_USERNAME", "username"}, {ID_CARD_DIFF_FLAGS_PASSWORD, "ID_CARD_DIFF_FLAGS_PASSWORD", "password"}, {ID_CARD_DIFF_FLAGS_ISSUER, "ID_CARD_DIFF_FLAGS_ISSUER", "issuer"}, {ID_CARD_DIFF_FLAGS_RULES, "ID_CARD_DIFF_FLAGS_RULES", "rules"}, {ID_CARD_DIFF_FLAGS_SERVICES, "ID_CARD_DIFF_FLAGS_SERVICES", "services"}, {ID_CARD_DIFF_FLAGS_TRUST_ANCHOR, "ID_CARD_DIFF_FLAGS_TRUST_ANCHOR", "trust-anchor"}, {0, NULL, NULL}};
		GType id_card_diff_flags_type_id;
		id_card_diff_flags_type_id = g_enum_register_static ("IdCardDiffFlags", values);
		g_once_init_leave (&id_card_diff_flags_type_id__volatile, id_card_diff_flags_type_id);
	}
	return id_card_diff_flags_type_id__volatile;
}


static void _vala_Rule_array_free (Rule* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			rule_destroy (&array[i]);
		}
	}
	g_free (array);
}


#line 105 "moonshot-id.vala"
gboolean id_card_IsNoIdentity (IdCard* self) {
#line 536 "moonshot-id.c"
	gboolean result = FALSE;
#line 105 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 540 "moonshot-id.c"
	result = _vala_strcmp0 (self->priv->_display_name, ID_CARD_NO_IDENTITY) == 0;
#line 107 "moonshot-id.vala"
	return result;
#line 544 "moonshot-id.c"
}


#line 120 "moonshot-id.vala"
gint id_card_Compare (IdCard* self, IdCard* other) {
#line 550 "moonshot-id.c"
	gint result = 0;
	gint diff;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 120 "moonshot-id.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 120 "moonshot-id.vala"
	g_return_val_if_fail (other != NULL, 0);
#line 122 "moonshot-id.vala"
	diff = 0;
#line 123 "moonshot-id.vala"
	if (_vala_strcmp0 (self->priv->_display_name, other->priv->_display_name) != 0) {
#line 124 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_DISPLAY_NAME);
#line 567 "moonshot-id.c"
	}
#line 125 "moonshot-id.vala"
	if (_vala_strcmp0 (self->priv->_username, other->priv->_username) != 0) {
#line 126 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_USERNAME);
#line 573 "moonshot-id.c"
	}
#line 127 "moonshot-id.vala"
	if (_vala_strcmp0 (id_card_get_password (self), id_card_get_password (other)) != 0) {
#line 128 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_PASSWORD);
#line 579 "moonshot-id.c"
	}
#line 129 "moonshot-id.vala"
	if (_vala_strcmp0 (self->priv->_issuer, other->priv->_issuer) != 0) {
#line 130 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_ISSUER);
#line 585 "moonshot-id.c"
	}
#line 131 "moonshot-id.vala"
	if (CompareRules (id_card_get_rules (self, &_tmp0_), _tmp0_, id_card_get_rules (other, &_tmp1_), _tmp1_) != 0) {
#line 132 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_RULES);
#line 591 "moonshot-id.c"
	}
#line 133 "moonshot-id.vala"
	if (CompareStringArray (id_card_get_services (self, &_tmp2_), _tmp2_, id_card_get_services (other, &_tmp3_), _tmp3_) != 0) {
#line 134 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_SERVICES);
#line 597 "moonshot-id.c"
	}
#line 135 "moonshot-id.vala"
	if (trust_anchor_Compare (self->priv->_trust_anchor, other->priv->_trust_anchor) != 0) {
#line 136 "moonshot-id.vala"
		diff = diff | (1 << ID_CARD_DIFF_FLAGS_TRUST_ANCHOR);
#line 603 "moonshot-id.c"
	}
#line 137 "moonshot-id.vala"
	fprintf (stdout, "Diff Flags: %x\n", (guint) diff);
#line 607 "moonshot-id.c"
	result = diff;
#line 138 "moonshot-id.vala"
	return result;
#line 611 "moonshot-id.c"
}


#line 141 "moonshot-id.vala"
IdCard* id_card_NewNoIdentity (void) {
#line 617 "moonshot-id.c"
	IdCard* result = NULL;
	IdCard* card;
#line 143 "moonshot-id.vala"
	card = id_card_new ();
#line 144 "moonshot-id.vala"
	id_card_set_display_name (card, ID_CARD_NO_IDENTITY);
#line 624 "moonshot-id.c"
	result = card;
#line 145 "moonshot-id.vala"
	return result;
#line 628 "moonshot-id.c"
}


#line 65 "moonshot-id.vala"
IdCard* id_card_construct (GType object_type) {
#line 634 "moonshot-id.c"
	IdCard * self = NULL;
#line 65 "moonshot-id.vala"
	self = (IdCard*) g_object_new (object_type, NULL);
#line 638 "moonshot-id.c"
	return self;
}


#line 65 "moonshot-id.vala"
IdCard* id_card_new (void) {
#line 65 "moonshot-id.vala"
	return id_card_construct (TYPE_ID_CARD);
#line 647 "moonshot-id.c"
}


const char* id_card_get_display_name (IdCard* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_display_name;
#line 71 "moonshot-id.vala"
	return result;
#line 657 "moonshot-id.c"
}


void id_card_set_display_name (IdCard* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_display_name = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_display_name), _tmp0_);
	g_object_notify ((GObject *) self, "display-name");
}


const char* id_card_get_username (IdCard* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_username;
#line 73 "moonshot-id.vala"
	return result;
#line 675 "moonshot-id.c"
}


void id_card_set_username (IdCard* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_username = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_username), _tmp0_);
	g_object_notify ((GObject *) self, "username");
}


const char* id_card_get_password (IdCard* self) {
	const char* result;
	const char* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = NULL;
#line 78 "moonshot-id.vala"
	if (self->priv->_password != NULL) {
#line 78 "moonshot-id.vala"
		_tmp0_ = self->priv->_password;
#line 696 "moonshot-id.c"
	} else {
#line 78 "moonshot-id.vala"
		_tmp0_ = "";
#line 700 "moonshot-id.c"
	}
	result = _tmp0_;
#line 78 "moonshot-id.vala"
	return result;
#line 705 "moonshot-id.c"
}


void id_card_set_password (IdCard* self, const char* value) {
	g_return_if_fail (self != NULL);
#line 81 "moonshot-id.vala"
	if (self->priv->_password != NULL) {
#line 82 "moonshot-id.vala"
		gnome_keyring_memory_free ((void*) self->priv->_password);
#line 83 "moonshot-id.vala"
		self->priv->_password = NULL;
#line 717 "moonshot-id.c"
	}
#line 85 "moonshot-id.vala"
	if (value != NULL) {
#line 86 "moonshot-id.vala"
		self->priv->_password = gnome_keyring_memory_strdup (value);
#line 723 "moonshot-id.c"
	}
	g_object_notify ((GObject *) self, "password");
}


const char* id_card_get_issuer (IdCard* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_issuer;
#line 93 "moonshot-id.vala"
	return result;
#line 735 "moonshot-id.c"
}


void id_card_set_issuer (IdCard* self, const char* value) {
	char* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_issuer = (_tmp0_ = g_strdup (value), _g_free0 (self->priv->_issuer), _tmp0_);
	g_object_notify ((GObject *) self, "issuer");
}


Rule* id_card_get_rules (IdCard* self, int* result_length1) {
	Rule* result;
	Rule* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	result = (_tmp0_ = self->priv->_rules, *result_length1 = self->priv->_rules_length1, _tmp0_);
#line 95 "moonshot-id.vala"
	return result;
#line 754 "moonshot-id.c"
}


static Rule* _vala_array_dup8 (Rule* self, int length) {
	Rule* result;
	int i;
	Rule _tmp0_ = {0};
	result = g_new0 (Rule, length);
	for (i = 0; i < length; i++) {
		result[i] = (rule_copy (&self[i], &_tmp0_), _tmp0_);
	}
	return result;
}


void id_card_set_rules (IdCard* self, Rule* value, int value_length1) {
	Rule* _tmp0_;
	Rule* _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_rules = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup8 (_tmp0_, value_length1)), self->priv->_rules = (_vala_Rule_array_free (self->priv->_rules, self->priv->_rules_length1), NULL), self->priv->_rules_length1 = value_length1, self->priv->__rules_size_ = self->priv->_rules_length1, _tmp1_);
}


char** id_card_get_services (IdCard* self, int* result_length1) {
	char** result;
	char** _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	result = (_tmp0_ = self->priv->_services, *result_length1 = self->priv->_services_length1, _tmp0_);
#line 96 "moonshot-id.vala"
	return result;
#line 785 "moonshot-id.c"
}


static char** _vala_array_dup9 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


void id_card_set_services (IdCard* self, char** value, int value_length1) {
	char** _tmp0_;
	char** _tmp1_;
	g_return_if_fail (self != NULL);
	self->priv->_services = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? ((gpointer) _tmp0_) : _vala_array_dup9 (_tmp0_, value_length1)), self->priv->_services = (_vala_array_free (self->priv->_services, self->priv->_services_length1, (GDestroyNotify) g_free), NULL), self->priv->_services_length1 = value_length1, self->priv->__services_size_ = self->priv->_services_length1, _tmp1_);
	g_object_notify ((GObject *) self, "services");
}


gboolean id_card_get_temporary (IdCard* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_temporary;
#line 97 "moonshot-id.vala"
	return result;
#line 815 "moonshot-id.c"
}


void id_card_set_temporary (IdCard* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_temporary = value;
	g_object_notify ((GObject *) self, "temporary");
}


TrustAnchor* id_card_get_trust_anchor (IdCard* self) {
	TrustAnchor* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_trust_anchor;
#line 99 "moonshot-id.vala"
	return result;
#line 832 "moonshot-id.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void id_card_set_trust_anchor (IdCard* self, TrustAnchor* value) {
	TrustAnchor* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_trust_anchor = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_trust_anchor), _tmp0_);
	g_object_notify ((GObject *) self, "trust-anchor");
}


const char* id_card_get_nai (IdCard* self) {
	const char* result;
	char* _tmp0_;
	char* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "moonshot-id.vala"
	self->priv->_nai = (_tmp1_ = g_strconcat (_tmp0_ = g_strconcat (self->priv->_username, "@", NULL), self->priv->_issuer, NULL), _g_free0 (self->priv->_nai), _tmp1_);
#line 856 "moonshot-id.c"
	_g_free0 (_tmp0_);
	result = self->priv->_nai;
#line 101 "moonshot-id.vala"
	return result;
#line 861 "moonshot-id.c"
}


gboolean id_card_get_store_password (IdCard* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_store_password;
#line 103 "moonshot-id.vala"
	return result;
#line 871 "moonshot-id.c"
}


void id_card_set_store_password (IdCard* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_store_password = value;
	g_object_notify ((GObject *) self, "store-password");
}


static void id_card_class_init (IdCardClass * klass) {
	id_card_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (IdCardPrivate));
	G_OBJECT_CLASS (klass)->get_property = id_card_get_property;
	G_OBJECT_CLASS (klass)->set_property = id_card_set_property;
	G_OBJECT_CLASS (klass)->finalize = id_card_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_DISPLAY_NAME, g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_USERNAME, g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_PASSWORD, g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_ISSUER, g_param_spec_string ("issuer", "issuer", "issuer", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_SERVICES, g_param_spec_boxed ("services", "services", "services", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_TEMPORARY, g_param_spec_boolean ("temporary", "temporary", "temporary", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_TRUST_ANCHOR, g_param_spec_object ("trust-anchor", "trust-anchor", "trust-anchor", TYPE_TRUST_ANCHOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_NAI, g_param_spec_string ("nai", "nai", "nai", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_STORE_PASSWORD, g_param_spec_boolean ("store-password", "store-password", "store-password", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void id_card_instance_init (IdCard * self) {
	Rule* _tmp0_ = NULL;
	char** _tmp1_ = NULL;
	self->priv = ID_CARD_GET_PRIVATE (self);
	self->priv->_display_name = g_strdup ("");
	self->priv->_username = g_strdup ("");
	self->priv->_issuer = g_strdup ("");
	self->priv->_rules = (_tmp0_ = g_new0 (Rule, 0), _tmp0_);
	self->priv->_rules_length1 = 0;
	self->priv->__rules_size_ = self->priv->_rules_length1;
	self->priv->_services = (_tmp1_ = g_new0 (char*, 0 + 1), _tmp1_);
	self->priv->_services_length1 = 0;
	self->priv->__services_size_ = self->priv->_services_length1;
	self->priv->_temporary = FALSE;
	self->priv->_trust_anchor = trust_anchor_new ();
	self->priv->_store_password = FALSE;
}


static void id_card_finalize (GObject* obj) {
	IdCard * self;
	self = ID_CARD (obj);
	{
#line 149 "moonshot-id.vala"
		id_card_set_password (self, NULL);
#line 925 "moonshot-id.c"
	}
	_g_free0 (self->priv->_nai);
	_g_free0 (self->priv->_display_name);
	_g_free0 (self->priv->_username);
	_g_free0 (self->priv->_issuer);
	self->priv->_rules = (_vala_Rule_array_free (self->priv->_rules, self->priv->_rules_length1), NULL);
	self->priv->_services = (_vala_array_free (self->priv->_services, self->priv->_services_length1, (GDestroyNotify) g_free), NULL);
	_g_object_unref0 (self->priv->_trust_anchor);
	G_OBJECT_CLASS (id_card_parent_class)->finalize (obj);
}


GType id_card_get_type (void) {
	static volatile gsize id_card_type_id__volatile = 0;
	if (g_once_init_enter (&id_card_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IdCardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) id_card_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IdCard), 0, (GInstanceInitFunc) id_card_instance_init, NULL };
		GType id_card_type_id;
		id_card_type_id = g_type_register_static (G_TYPE_OBJECT, "IdCard", &g_define_type_info, 0);
		g_once_init_leave (&id_card_type_id__volatile, id_card_type_id);
	}
	return id_card_type_id__volatile;
}


static void id_card_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	IdCard * self;
	int length;
	self = ID_CARD (object);
	switch (property_id) {
		case ID_CARD_DISPLAY_NAME:
		g_value_set_string (value, id_card_get_display_name (self));
		break;
		case ID_CARD_USERNAME:
		g_value_set_string (value, id_card_get_username (self));
		break;
		case ID_CARD_PASSWORD:
		g_value_set_string (value, id_card_get_password (self));
		break;
		case ID_CARD_ISSUER:
		g_value_set_string (value, id_card_get_issuer (self));
		break;
		case ID_CARD_SERVICES:
		g_value_set_boxed (value, id_card_get_services (self, &length));
		break;
		case ID_CARD_TEMPORARY:
		g_value_set_boolean (value, id_card_get_temporary (self));
		break;
		case ID_CARD_TRUST_ANCHOR:
		g_value_set_object (value, id_card_get_trust_anchor (self));
		break;
		case ID_CARD_NAI:
		g_value_set_string (value, id_card_get_nai (self));
		break;
		case ID_CARD_STORE_PASSWORD:
		g_value_set_boolean (value, id_card_get_store_password (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void id_card_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	IdCard * self;
	gpointer boxed;
	self = ID_CARD (object);
	switch (property_id) {
		case ID_CARD_DISPLAY_NAME:
		id_card_set_display_name (self, g_value_get_string (value));
		break;
		case ID_CARD_USERNAME:
		id_card_set_username (self, g_value_get_string (value));
		break;
		case ID_CARD_PASSWORD:
		id_card_set_password (self, g_value_get_string (value));
		break;
		case ID_CARD_ISSUER:
		id_card_set_issuer (self, g_value_get_string (value));
		break;
		case ID_CARD_SERVICES:
		boxed = g_value_get_boxed (value);
		id_card_set_services (self, boxed, g_strv_length (boxed));
		break;
		case ID_CARD_TEMPORARY:
		id_card_set_temporary (self, g_value_get_boolean (value));
		break;
		case ID_CARD_TRUST_ANCHOR:
		id_card_set_trust_anchor (self, g_value_get_object (value));
		break;
		case ID_CARD_STORE_PASSWORD:
		id_card_set_store_password (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 153 "moonshot-id.vala"
gint CompareRules (Rule* a, int a_length1, Rule* b, int b_length1) {
#line 1028 "moonshot-id.c"
	gint result = 0;
#line 155 "moonshot-id.vala"
	if (a_length1 != b_length1) {
#line 1032 "moonshot-id.c"
		result = 1;
#line 156 "moonshot-id.vala"
		return result;
#line 1036 "moonshot-id.c"
	}
	{
		gint i;
#line 157 "moonshot-id.vala"
		i = 0;
#line 1042 "moonshot-id.c"
		{
			gboolean _tmp0_;
#line 157 "moonshot-id.vala"
			_tmp0_ = TRUE;
#line 157 "moonshot-id.vala"
			while (TRUE) {
#line 1049 "moonshot-id.c"
				Rule _tmp1_;
				Rule _tmp2_;
#line 157 "moonshot-id.vala"
				if (!_tmp0_) {
#line 157 "moonshot-id.vala"
					i++;
#line 1056 "moonshot-id.c"
				}
#line 157 "moonshot-id.vala"
				_tmp0_ = FALSE;
#line 157 "moonshot-id.vala"
				if (!(i < a_length1)) {
#line 157 "moonshot-id.vala"
					break;
#line 1064 "moonshot-id.c"
				}
#line 158 "moonshot-id.vala"
				if (rule_Compare ((_tmp1_ = a[i], &_tmp1_), (_tmp2_ = b[i], &_tmp2_)) != 0) {
#line 1068 "moonshot-id.c"
					result = 1;
#line 159 "moonshot-id.vala"
					return result;
#line 1072 "moonshot-id.c"
				}
			}
		}
	}
	result = 0;
#line 161 "moonshot-id.vala"
	return result;
#line 1080 "moonshot-id.c"
}


#line 164 "moonshot-id.vala"
gint CompareStringArray (char** a, int a_length1, char** b, int b_length1) {
#line 1086 "moonshot-id.c"
	gint result = 0;
#line 166 "moonshot-id.vala"
	if (a_length1 != b_length1) {
#line 1090 "moonshot-id.c"
		result = 1;
#line 167 "moonshot-id.vala"
		return result;
#line 1094 "moonshot-id.c"
	}
	{
		gint i;
#line 168 "moonshot-id.vala"
		i = 0;
#line 1100 "moonshot-id.c"
		{
			gboolean _tmp0_;
#line 168 "moonshot-id.vala"
			_tmp0_ = TRUE;
#line 168 "moonshot-id.vala"
			while (TRUE) {
#line 168 "moonshot-id.vala"
				if (!_tmp0_) {
#line 168 "moonshot-id.vala"
					i++;
#line 1111 "moonshot-id.c"
				}
#line 168 "moonshot-id.vala"
				_tmp0_ = FALSE;
#line 168 "moonshot-id.vala"
				if (!(i < a_length1)) {
#line 168 "moonshot-id.vala"
					break;
#line 1119 "moonshot-id.c"
				}
#line 169 "moonshot-id.vala"
				if (_vala_strcmp0 (a[i], b[i]) != 0) {
#line 1123 "moonshot-id.c"
					result = 1;
#line 170 "moonshot-id.vala"
					return result;
#line 1127 "moonshot-id.c"
				}
			}
		}
	}
	result = 0;
#line 172 "moonshot-id.vala"
	return result;
#line 1135 "moonshot-id.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




