/* moonshot-idcard-widget.c generated by valac 0.10.4, the Vala compiler
 * generated from moonshot-idcard-widget.vala, do not modify */

/*
 * Copyright (c) 2011-2014, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <string.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <atk/atk.h>


#define TYPE_ID_CARD_WIDGET (id_card_widget_get_type ())
#define ID_CARD_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD_WIDGET, IdCardWidget))
#define ID_CARD_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD_WIDGET, IdCardWidgetClass))
#define IS_ID_CARD_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD_WIDGET))
#define IS_ID_CARD_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD_WIDGET))
#define ID_CARD_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD_WIDGET, IdCardWidgetClass))

typedef struct _IdCardWidget IdCardWidget;
typedef struct _IdCardWidgetClass IdCardWidgetClass;
typedef struct _IdCardWidgetPrivate IdCardWidgetPrivate;

#define TYPE_ID_CARD (id_card_get_type ())
#define ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD, IdCard))
#define ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD, IdCardClass))
#define IS_ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD))
#define IS_ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD))
#define ID_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD, IdCardClass))

typedef struct _IdCard IdCard;
typedef struct _IdCardClass IdCardClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _IdCardWidget {
	GtkBox parent_instance;
	IdCardWidgetPrivate * priv;
};

struct _IdCardWidgetClass {
	GtkBoxClass parent_class;
};

struct _IdCardWidgetPrivate {
	IdCard* _id_card;
	GtkVBox* main_vbox;
	GtkHBox* table;
	GtkButton* _delete_button;
	GtkButton* _details_button;
	GtkButton* _send_button;
	GtkHButtonBox* hbutton_box;
	GtkEventBox* event_box;
	GtkLabel* label;
};


static gpointer id_card_widget_parent_class = NULL;

GType id_card_widget_get_type (void) G_GNUC_CONST;
GType id_card_get_type (void) G_GNUC_CONST;
#define ID_CARD_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ID_CARD_WIDGET, IdCardWidgetPrivate))
enum  {
	ID_CARD_WIDGET_DUMMY_PROPERTY,
	ID_CARD_WIDGET_ID_CARD,
	ID_CARD_WIDGET_DELETE_BUTTON,
	ID_CARD_WIDGET_DETAILS_BUTTON,
	ID_CARD_WIDGET_SEND_BUTTON
};
void id_card_widget_collapse (IdCardWidget* self);
static void id_card_widget_set_idcard_color (IdCardWidget* self);
void id_card_widget_expand (IdCardWidget* self);
static gboolean id_card_widget_button_press_cb (IdCardWidget* self);
static void id_card_widget_delete_button_cb (IdCardWidget* self);
static void id_card_widget_details_button_cb (IdCardWidget* self);
static void id_card_widget_send_button_cb (IdCardWidget* self);
void id_card_widget_update_id_card_label (IdCardWidget* self);
IdCard* id_card_widget_get_id_card (IdCardWidget* self);
const char* id_card_get_display_name (IdCard* self);
char** id_card_get_services (IdCard* self, int* result_length1);
IdCardWidget* id_card_widget_new (IdCard* id_card);
IdCardWidget* id_card_widget_construct (GType object_type, IdCard* id_card);
void id_card_widget_set_id_card (IdCardWidget* self, IdCard* value);
GdkPixbuf* get_pixbuf (IdCard* id);
static void id_card_widget_set_delete_button (IdCardWidget* self, GtkButton* value);
static void id_card_widget_set_details_button (IdCardWidget* self, GtkButton* value);
static void id_card_widget_set_send_button (IdCardWidget* self, GtkButton* value);
static void id_card_widget_set_atk_name_description (IdCardWidget* self, GtkWidget* widget, const char* name, const char* description);
GtkButton* id_card_widget_get_delete_button (IdCardWidget* self);
GtkButton* id_card_widget_get_details_button (IdCardWidget* self);
GtkButton* id_card_widget_get_send_button (IdCardWidget* self);
static void _id_card_widget_delete_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _id_card_widget_details_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _id_card_widget_send_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static gboolean _id_card_widget_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void id_card_widget_finalize (GObject* obj);
static void id_card_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void id_card_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);



#line 53 "moonshot-idcard-widget.vala"
void id_card_widget_collapse (IdCardWidget* self) {
#line 53 "moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 55 "moonshot-idcard-widget.vala"
	gtk_widget_set_visible ((GtkWidget*) self->priv->hbutton_box, FALSE);
#line 57 "moonshot-idcard-widget.vala"
	id_card_widget_set_idcard_color (self);
#line 148 "moonshot-idcard-widget.c"
}


#line 60 "moonshot-idcard-widget.vala"
void id_card_widget_expand (IdCardWidget* self) {
#line 60 "moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 62 "moonshot-idcard-widget.vala"
	gtk_widget_set_visible ((GtkWidget*) self->priv->hbutton_box, TRUE);
#line 64 "moonshot-idcard-widget.vala"
	id_card_widget_set_idcard_color (self);
#line 65 "moonshot-idcard-widget.vala"
	g_signal_emit_by_name (self, "expanded");
#line 162 "moonshot-idcard-widget.c"
}


#line 68 "moonshot-idcard-widget.vala"
static gboolean id_card_widget_button_press_cb (IdCardWidget* self) {
#line 168 "moonshot-idcard-widget.c"
	gboolean result = FALSE;
#line 68 "moonshot-idcard-widget.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 70 "moonshot-idcard-widget.vala"
	if (gtk_widget_get_visible ((GtkWidget*) self->priv->hbutton_box)) {
#line 71 "moonshot-idcard-widget.vala"
		id_card_widget_collapse (self);
#line 176 "moonshot-idcard-widget.c"
	} else {
#line 73 "moonshot-idcard-widget.vala"
		id_card_widget_expand (self);
#line 180 "moonshot-idcard-widget.c"
	}
	result = FALSE;
#line 75 "moonshot-idcard-widget.vala"
	return result;
#line 185 "moonshot-idcard-widget.c"
}


#line 78 "moonshot-idcard-widget.vala"
static void id_card_widget_delete_button_cb (IdCardWidget* self) {
#line 78 "moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 80 "moonshot-idcard-widget.vala"
	g_signal_emit_by_name (self, "remove-id");
#line 195 "moonshot-idcard-widget.c"
}


#line 83 "moonshot-idcard-widget.vala"
static void id_card_widget_details_button_cb (IdCardWidget* self) {
#line 83 "moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 85 "moonshot-idcard-widget.vala"
	g_signal_emit_by_name (self, "details-id");
#line 205 "moonshot-idcard-widget.c"
}


#line 88 "moonshot-idcard-widget.vala"
static void id_card_widget_send_button_cb (IdCardWidget* self) {
#line 88 "moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 90 "moonshot-idcard-widget.vala"
	g_signal_emit_by_name (self, "send-id");
#line 215 "moonshot-idcard-widget.c"
}


#line 93 "moonshot-idcard-widget.vala"
static void id_card_widget_set_idcard_color (IdCardWidget* self) {
#line 221 "moonshot-idcard-widget.c"
	GdkColor color = {0};
	GtkStateType state;
#line 93 "moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 226 "moonshot-idcard-widget.c"
	memset (&color, 0, sizeof (GdkColor));
#line 97 "moonshot-idcard-widget.vala"
	if (gtk_widget_get_visible ((GtkWidget*) self->priv->hbutton_box) == FALSE) {
#line 99 "moonshot-idcard-widget.vala"
		color.red = (guint16) 65535;
#line 100 "moonshot-idcard-widget.vala"
		color.green = (guint16) 65535;
#line 101 "moonshot-idcard-widget.vala"
		color.blue = (guint16) 65535;
#line 236 "moonshot-idcard-widget.c"
	} else {
#line 105 "moonshot-idcard-widget.vala"
		color.red = (guint16) 33333;
#line 106 "moonshot-idcard-widget.vala"
		color.green = (guint16) 33333;
#line 107 "moonshot-idcard-widget.vala"
		color.blue = (guint16) 60000;
#line 244 "moonshot-idcard-widget.c"
	}
#line 109 "moonshot-idcard-widget.vala"
	state = gtk_widget_get_state ((GtkWidget*) self);
#line 110 "moonshot-idcard-widget.vala"
	gtk_widget_modify_bg ((GtkWidget*) self->priv->event_box, state, &color);
#line 250 "moonshot-idcard-widget.c"
}


#line 113 "moonshot-idcard-widget.vala"
void id_card_widget_update_id_card_label (IdCardWidget* self) {
#line 256 "moonshot-idcard-widget.c"
	char* services_text;
	char* display_name;
	char* _tmp8_;
	char* _tmp9_;
#line 113 "moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 116 "moonshot-idcard-widget.vala"
	services_text = g_strdup ("");
#line 118 "moonshot-idcard-widget.vala"
	display_name = g_markup_printf_escaped ("<big>%s</big>", id_card_get_display_name (self->priv->_id_card));
#line 267 "moonshot-idcard-widget.c"
	{
		gint i;
#line 119 "moonshot-idcard-widget.vala"
		i = 0;
#line 272 "moonshot-idcard-widget.c"
		{
			gboolean _tmp0_;
#line 119 "moonshot-idcard-widget.vala"
			_tmp0_ = TRUE;
#line 119 "moonshot-idcard-widget.vala"
			while (TRUE) {
#line 279 "moonshot-idcard-widget.c"
				gint _tmp1_;
				gint _tmp2_;
				char* service;
				gint _tmp3_;
#line 119 "moonshot-idcard-widget.vala"
				if (!_tmp0_) {
#line 119 "moonshot-idcard-widget.vala"
					i++;
#line 288 "moonshot-idcard-widget.c"
				}
#line 119 "moonshot-idcard-widget.vala"
				_tmp0_ = FALSE;
#line 119 "moonshot-idcard-widget.vala"
				if (!(i < _tmp1_)) {
#line 119 "moonshot-idcard-widget.vala"
					break;
#line 296 "moonshot-idcard-widget.c"
				}
#line 121 "moonshot-idcard-widget.vala"
				service = g_strdup (id_card_get_services (self->priv->_id_card, &_tmp2_)[i]);
#line 123 "moonshot-idcard-widget.vala"
				if (i == (_tmp3_ - 1)) {
#line 302 "moonshot-idcard-widget.c"
					char* _tmp4_;
					char* _tmp5_;
#line 124 "moonshot-idcard-widget.vala"
					services_text = (_tmp5_ = g_strconcat (services_text, _tmp4_ = g_markup_printf_escaped ("<i>%s</i>", service), NULL), _g_free0 (services_text), _tmp5_);
#line 307 "moonshot-idcard-widget.c"
					_g_free0 (_tmp4_);
				} else {
					char* _tmp6_;
					char* _tmp7_;
#line 126 "moonshot-idcard-widget.vala"
					services_text = (_tmp7_ = g_strconcat (services_text, _tmp6_ = g_markup_printf_escaped ("<i>%s, </i>", service), NULL), _g_free0 (services_text), _tmp7_);
#line 314 "moonshot-idcard-widget.c"
					_g_free0 (_tmp6_);
				}
				_g_free0 (service);
			}
		}
	}
#line 128 "moonshot-idcard-widget.vala"
	gtk_label_set_markup (self->priv->label, _tmp9_ = g_strconcat (_tmp8_ = g_strconcat (display_name, "\n", NULL), services_text, NULL));
#line 323 "moonshot-idcard-widget.c"
	_g_free0 (_tmp9_);
	_g_free0 (_tmp8_);
	_g_free0 (display_name);
	_g_free0 (services_text);
}


#line 78 "moonshot-idcard-widget.vala"
static void _id_card_widget_delete_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 333 "moonshot-idcard-widget.c"
	id_card_widget_delete_button_cb (self);
}


#line 83 "moonshot-idcard-widget.vala"
static void _id_card_widget_details_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 340 "moonshot-idcard-widget.c"
	id_card_widget_details_button_cb (self);
}


#line 88 "moonshot-idcard-widget.vala"
static void _id_card_widget_send_button_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 347 "moonshot-idcard-widget.c"
	id_card_widget_send_button_cb (self);
}


#line 68 "moonshot-idcard-widget.vala"
static gboolean _id_card_widget_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
#line 354 "moonshot-idcard-widget.c"
	gboolean result;
	result = id_card_widget_button_press_cb (self);
	return result;
}


#line 131 "moonshot-idcard-widget.vala"
IdCardWidget* id_card_widget_construct (GType object_type, IdCard* id_card) {
#line 363 "moonshot-idcard-widget.c"
	IdCardWidget * self;
	GdkPixbuf* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* image;
	GtkLabel* _tmp2_;
	GtkHBox* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkHButtonBox* _tmp7_;
	GtkVBox* _tmp8_;
	GtkEventBox* _tmp9_;
#line 131 "moonshot-idcard-widget.vala"
	g_return_val_if_fail (id_card != NULL, NULL);
#line 378 "moonshot-idcard-widget.c"
	self = g_object_newv (object_type, 0, NULL);
#line 133 "moonshot-idcard-widget.vala"
	id_card_widget_set_id_card (self, id_card);
#line 135 "moonshot-idcard-widget.vala"
	image = (_tmp1_ = g_object_ref_sink ((GtkImage*) gtk_image_new_from_pixbuf (_tmp0_ = get_pixbuf (id_card))), _g_object_unref0 (_tmp0_), _tmp1_);
#line 137 "moonshot-idcard-widget.vala"
	self->priv->label = (_tmp2_ = g_object_ref_sink ((GtkLabel*) gtk_label_new (NULL)), _g_object_unref0 (self->priv->label), _tmp2_);
#line 138 "moonshot-idcard-widget.vala"
	gtk_misc_set_alignment ((GtkMisc*) self->priv->label, (float) 0, (float) 0.5);
#line 139 "moonshot-idcard-widget.vala"
	gtk_label_set_ellipsize (self->priv->label, PANGO_ELLIPSIZE_END);
#line 140 "moonshot-idcard-widget.vala"
	id_card_widget_update_id_card_label (self);
#line 142 "moonshot-idcard-widget.vala"
	self->priv->table = (_tmp3_ = g_object_ref_sink ((GtkHBox*) gtk_hbox_new (FALSE, 6)), _g_object_unref0 (self->priv->table), _tmp3_);
#line 143 "moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) self->priv->table, (GtkWidget*) image, FALSE, FALSE, (guint) 0);
#line 144 "moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) self->priv->table, (GtkWidget*) self->priv->label, TRUE, TRUE, (guint) 0);
#line 146 "moonshot-idcard-widget.vala"
	id_card_widget_set_delete_button (self, _tmp4_ = g_object_ref_sink ((GtkButton*) gtk_button_new_with_label (_ ("Delete"))));
#line 400 "moonshot-idcard-widget.c"
	_g_object_unref0 (_tmp4_);
#line 147 "moonshot-idcard-widget.vala"
	id_card_widget_set_details_button (self, _tmp5_ = g_object_ref_sink ((GtkButton*) gtk_button_new_with_label (_ ("View details"))));
#line 404 "moonshot-idcard-widget.c"
	_g_object_unref0 (_tmp5_);
#line 148 "moonshot-idcard-widget.vala"
	id_card_widget_set_send_button (self, _tmp6_ = g_object_ref_sink ((GtkButton*) gtk_button_new_with_label (_ ("Send"))));
#line 408 "moonshot-idcard-widget.c"
	_g_object_unref0 (_tmp6_);
#line 149 "moonshot-idcard-widget.vala"
	id_card_widget_set_atk_name_description (self, (GtkWidget*) self->priv->_delete_button, _ ("Delete"), _ ("Delete this ID Card"));
#line 150 "moonshot-idcard-widget.vala"
	id_card_widget_set_atk_name_description (self, (GtkWidget*) self->priv->_details_button, _ ("Details"), _ ("View the details of this ID Card"));
#line 151 "moonshot-idcard-widget.vala"
	id_card_widget_set_atk_name_description (self, (GtkWidget*) self->priv->_send_button, _ ("Send"), _ ("Send this ID Card"));
#line 152 "moonshot-idcard-widget.vala"
	self->priv->hbutton_box = (_tmp7_ = g_object_ref_sink ((GtkHButtonBox*) gtk_hbutton_box_new ()), _g_object_unref0 (self->priv->hbutton_box), _tmp7_);
#line 153 "moonshot-idcard-widget.vala"
	gtk_box_pack_end ((GtkBox*) self->priv->hbutton_box, (GtkWidget*) self->priv->_delete_button, TRUE, TRUE, 0);
#line 154 "moonshot-idcard-widget.vala"
	gtk_box_pack_end ((GtkBox*) self->priv->hbutton_box, (GtkWidget*) self->priv->_details_button, TRUE, TRUE, 0);
#line 155 "moonshot-idcard-widget.vala"
	gtk_box_pack_end ((GtkBox*) self->priv->hbutton_box, (GtkWidget*) self->priv->_send_button, TRUE, TRUE, 0);
#line 156 "moonshot-idcard-widget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self->priv->_send_button, FALSE);
#line 158 "moonshot-idcard-widget.vala"
	g_signal_connect_object (self->priv->_delete_button, "clicked", (GCallback) _id_card_widget_delete_button_cb_gtk_button_clicked, self, 0);
#line 159 "moonshot-idcard-widget.vala"
	g_signal_connect_object (self->priv->_details_button, "clicked", (GCallback) _id_card_widget_details_button_cb_gtk_button_clicked, self, 0);
#line 160 "moonshot-idcard-widget.vala"
	g_signal_connect_object (self->priv->_send_button, "clicked", (GCallback) _id_card_widget_send_button_cb_gtk_button_clicked, self, 0);
#line 162 "moonshot-idcard-widget.vala"
	self->priv->main_vbox = (_tmp8_ = g_object_ref_sink ((GtkVBox*) gtk_vbox_new (FALSE, 12)), _g_object_unref0 (self->priv->main_vbox), _tmp8_);
#line 163 "moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) self->priv->main_vbox, (GtkWidget*) self->priv->table, TRUE, TRUE, (guint) 0);
#line 164 "moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) self->priv->main_vbox, (GtkWidget*) self->priv->hbutton_box, FALSE, FALSE, (guint) 0);
#line 165 "moonshot-idcard-widget.vala"
	gtk_container_set_border_width ((GtkContainer*) self->priv->main_vbox, (guint) 12);
#line 167 "moonshot-idcard-widget.vala"
	self->priv->event_box = (_tmp9_ = g_object_ref_sink ((GtkEventBox*) gtk_event_box_new ()), _g_object_unref0 (self->priv->event_box), _tmp9_);
#line 168 "moonshot-idcard-widget.vala"
	gtk_container_add ((GtkContainer*) self->priv->event_box, (GtkWidget*) self->priv->main_vbox);
#line 169 "moonshot-idcard-widget.vala"
	g_signal_connect_object ((GtkWidget*) self->priv->event_box, "button-press-event", (GCallback) _id_card_widget_button_press_cb_gtk_widget_button_press_event, self, 0);
#line 170 "moonshot-idcard-widget.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) self->priv->event_box, TRUE, TRUE, 0);
#line 172 "moonshot-idcard-widget.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 173 "moonshot-idcard-widget.vala"
	gtk_widget_hide ((GtkWidget*) self->priv->hbutton_box);
#line 175 "moonshot-idcard-widget.vala"
	id_card_widget_set_idcard_color (self);
#line 454 "moonshot-idcard-widget.c"
	_g_object_unref0 (image);
	return self;
}


#line 131 "moonshot-idcard-widget.vala"
IdCardWidget* id_card_widget_new (IdCard* id_card) {
#line 131 "moonshot-idcard-widget.vala"
	return id_card_widget_construct (TYPE_ID_CARD_WIDGET, id_card);
#line 464 "moonshot-idcard-widget.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 178 "moonshot-idcard-widget.vala"
static void id_card_widget_set_atk_name_description (IdCardWidget* self, GtkWidget* widget, const char* name, const char* description) {
#line 475 "moonshot-idcard-widget.c"
	AtkObject* atk_widget;
#line 178 "moonshot-idcard-widget.vala"
	g_return_if_fail (self != NULL);
#line 178 "moonshot-idcard-widget.vala"
	g_return_if_fail (widget != NULL);
#line 178 "moonshot-idcard-widget.vala"
	g_return_if_fail (name != NULL);
#line 178 "moonshot-idcard-widget.vala"
	g_return_if_fail (description != NULL);
#line 180 "moonshot-idcard-widget.vala"
	atk_widget = _g_object_ref0 (gtk_widget_get_accessible (widget));
#line 182 "moonshot-idcard-widget.vala"
	atk_object_set_name (atk_widget, name);
#line 183 "moonshot-idcard-widget.vala"
	atk_object_set_description (atk_widget, description);
#line 491 "moonshot-idcard-widget.c"
	_g_object_unref0 (atk_widget);
}


IdCard* id_card_widget_get_id_card (IdCardWidget* self) {
	IdCard* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_id_card;
#line 36 "moonshot-idcard-widget.vala"
	return result;
#line 502 "moonshot-idcard-widget.c"
}


void id_card_widget_set_id_card (IdCardWidget* self, IdCard* value) {
	IdCard* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_id_card = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_id_card), _tmp0_);
	g_object_notify ((GObject *) self, "id-card");
}


GtkButton* id_card_widget_get_delete_button (IdCardWidget* self) {
	GtkButton* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_delete_button;
#line 40 "moonshot-idcard-widget.vala"
	return result;
#line 520 "moonshot-idcard-widget.c"
}


static void id_card_widget_set_delete_button (IdCardWidget* self, GtkButton* value) {
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_delete_button = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_delete_button), _tmp0_);
	g_object_notify ((GObject *) self, "delete-button");
}


GtkButton* id_card_widget_get_details_button (IdCardWidget* self) {
	GtkButton* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_details_button;
#line 41 "moonshot-idcard-widget.vala"
	return result;
#line 538 "moonshot-idcard-widget.c"
}


static void id_card_widget_set_details_button (IdCardWidget* self, GtkButton* value) {
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_details_button = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_details_button), _tmp0_);
	g_object_notify ((GObject *) self, "details-button");
}


GtkButton* id_card_widget_get_send_button (IdCardWidget* self) {
	GtkButton* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_send_button;
#line 42 "moonshot-idcard-widget.vala"
	return result;
#line 556 "moonshot-idcard-widget.c"
}


static void id_card_widget_set_send_button (IdCardWidget* self, GtkButton* value) {
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_send_button = (_tmp0_ = _g_object_ref0 (value), _g_object_unref0 (self->priv->_send_button), _tmp0_);
	g_object_notify ((GObject *) self, "send-button");
}


static void id_card_widget_class_init (IdCardWidgetClass * klass) {
	id_card_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (IdCardWidgetPrivate));
	G_OBJECT_CLASS (klass)->get_property = id_card_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = id_card_widget_set_property;
	G_OBJECT_CLASS (klass)->finalize = id_card_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_WIDGET_ID_CARD, g_param_spec_object ("id-card", "id-card", "id-card", TYPE_ID_CARD, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_WIDGET_DELETE_BUTTON, g_param_spec_object ("delete-button", "delete-button", "delete-button", GTK_TYPE_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_WIDGET_DETAILS_BUTTON, g_param_spec_object ("details-button", "details-button", "details-button", GTK_TYPE_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ID_CARD_WIDGET_SEND_BUTTON, g_param_spec_object ("send-button", "send-button", "send-button", GTK_TYPE_BUTTON, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("expanded", TYPE_ID_CARD_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("remove_id", TYPE_ID_CARD_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("details_id", TYPE_ID_CARD_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("send_id", TYPE_ID_CARD_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void id_card_widget_instance_init (IdCardWidget * self) {
	self->priv = ID_CARD_WIDGET_GET_PRIVATE (self);
	self->priv->_id_card = NULL;
	self->priv->_delete_button = NULL;
	self->priv->_details_button = NULL;
	self->priv->_send_button = NULL;
}


static void id_card_widget_finalize (GObject* obj) {
	IdCardWidget * self;
	self = ID_CARD_WIDGET (obj);
	_g_object_unref0 (self->priv->_id_card);
	_g_object_unref0 (self->priv->main_vbox);
	_g_object_unref0 (self->priv->table);
	_g_object_unref0 (self->priv->_delete_button);
	_g_object_unref0 (self->priv->_details_button);
	_g_object_unref0 (self->priv->_send_button);
	_g_object_unref0 (self->priv->hbutton_box);
	_g_object_unref0 (self->priv->event_box);
	_g_object_unref0 (self->priv->label);
	G_OBJECT_CLASS (id_card_widget_parent_class)->finalize (obj);
}


GType id_card_widget_get_type (void) {
	static volatile gsize id_card_widget_type_id__volatile = 0;
	if (g_once_init_enter (&id_card_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IdCardWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) id_card_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IdCardWidget), 0, (GInstanceInitFunc) id_card_widget_instance_init, NULL };
		GType id_card_widget_type_id;
		id_card_widget_type_id = g_type_register_static (GTK_TYPE_BOX, "IdCardWidget", &g_define_type_info, 0);
		g_once_init_leave (&id_card_widget_type_id__volatile, id_card_widget_type_id);
	}
	return id_card_widget_type_id__volatile;
}


static void id_card_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	IdCardWidget * self;
	self = ID_CARD_WIDGET (object);
	switch (property_id) {
		case ID_CARD_WIDGET_ID_CARD:
		g_value_set_object (value, id_card_widget_get_id_card (self));
		break;
		case ID_CARD_WIDGET_DELETE_BUTTON:
		g_value_set_object (value, id_card_widget_get_delete_button (self));
		break;
		case ID_CARD_WIDGET_DETAILS_BUTTON:
		g_value_set_object (value, id_card_widget_get_details_button (self));
		break;
		case ID_CARD_WIDGET_SEND_BUTTON:
		g_value_set_object (value, id_card_widget_get_send_button (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void id_card_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	IdCardWidget * self;
	self = ID_CARD_WIDGET (object);
	switch (property_id) {
		case ID_CARD_WIDGET_ID_CARD:
		id_card_widget_set_id_card (self, g_value_get_object (value));
		break;
		case ID_CARD_WIDGET_DELETE_BUTTON:
		id_card_widget_set_delete_button (self, g_value_get_object (value));
		break;
		case ID_CARD_WIDGET_DETAILS_BUTTON:
		id_card_widget_set_details_button (self, g_value_get_object (value));
		break;
		case ID_CARD_WIDGET_SEND_BUTTON:
		id_card_widget_set_send_button (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




