/* moonshot-keyring-store.c generated by valac 0.10.4, the Vala compiler
 * generated from moonshot-keyring-store.vala, do not modify */

/*
 * Copyright (c) 2011-2014, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gnome-keyring.h>
#include <stdio.h>


#define TYPE_IIDENTITY_CARD_STORE (iidentity_card_store_get_type ())
#define IIDENTITY_CARD_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IIDENTITY_CARD_STORE, IIdentityCardStore))
#define IS_IIDENTITY_CARD_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IIDENTITY_CARD_STORE))
#define IIDENTITY_CARD_STORE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_IIDENTITY_CARD_STORE, IIdentityCardStoreIface))

typedef struct _IIdentityCardStore IIdentityCardStore;
typedef struct _IIdentityCardStoreIface IIdentityCardStoreIface;

#define TYPE_ID_CARD (id_card_get_type ())
#define ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD, IdCard))
#define ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD, IdCardClass))
#define IS_ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD))
#define IS_ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD))
#define ID_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD, IdCardClass))

typedef struct _IdCard IdCard;
typedef struct _IdCardClass IdCardClass;

#define IIDENTITY_CARD_STORE_TYPE_STORE_TYPE (iidentity_card_store_store_type_get_type ())

#define TYPE_KEYRING_STORE (keyring_store_get_type ())
#define KEYRING_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEYRING_STORE, KeyringStore))
#define KEYRING_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEYRING_STORE, KeyringStoreClass))
#define IS_KEYRING_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEYRING_STORE))
#define IS_KEYRING_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEYRING_STORE))
#define KEYRING_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEYRING_STORE, KeyringStoreClass))

typedef struct _KeyringStore KeyringStore;
typedef struct _KeyringStoreClass KeyringStoreClass;
typedef struct _KeyringStorePrivate KeyringStorePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free_gnome_keyring_found_free0(var) ((var == NULL) ? NULL : (var = (_g_list_free_gnome_keyring_found_free (var), NULL)))
#define _gnome_keyring_attribute_list_free0(var) ((var == NULL) ? NULL : (var = (gnome_keyring_attribute_list_free (var), NULL)))

#define TYPE_TRUST_ANCHOR (trust_anchor_get_type ())
#define TRUST_ANCHOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRUST_ANCHOR, TrustAnchor))
#define TRUST_ANCHOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRUST_ANCHOR, TrustAnchorClass))
#define IS_TRUST_ANCHOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRUST_ANCHOR))
#define IS_TRUST_ANCHOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRUST_ANCHOR))
#define TRUST_ANCHOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRUST_ANCHOR, TrustAnchorClass))

typedef struct _TrustAnchor TrustAnchor;
typedef struct _TrustAnchorClass TrustAnchorClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_RULE (rule_get_type ())
typedef struct _Rule Rule;

typedef enum  {
	IIDENTITY_CARD_STORE_STORE_TYPE_FLAT_FILE,
	IIDENTITY_CARD_STORE_STORE_TYPE_KEYRING
} IIdentityCardStoreStoreType;

struct _IIdentityCardStoreIface {
	GTypeInterface parent_iface;
	void (*add_card) (IIdentityCardStore* self, IdCard* card);
	gboolean (*remove_card) (IIdentityCardStore* self, IdCard* card);
	IdCard* (*update_card) (IIdentityCardStore* self, IdCard* card);
	IIdentityCardStoreStoreType (*get_store_type) (IIdentityCardStore* self);
	GeeLinkedList* (*get_card_list) (IIdentityCardStore* self);
};

struct _KeyringStore {
	GObject parent_instance;
	KeyringStorePrivate * priv;
};

struct _KeyringStoreClass {
	GObjectClass parent_class;
};

struct _KeyringStorePrivate {
	GeeLinkedList* id_card_list;
};

struct _Rule {
	char* pattern;
	char* always_confirm;
};


static gpointer keyring_store_parent_class = NULL;
static IIdentityCardStoreIface* keyring_store_iidentity_card_store_parent_iface = NULL;

GType id_card_get_type (void) G_GNUC_CONST;
GType iidentity_card_store_store_type_get_type (void) G_GNUC_CONST;
GType iidentity_card_store_get_type (void) G_GNUC_CONST;
GType keyring_store_get_type (void) G_GNUC_CONST;
#define KEYRING_STORE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_KEYRING_STORE, KeyringStorePrivate))
enum  {
	KEYRING_STORE_DUMMY_PROPERTY
};
#define KEYRING_STORE_keyring_store_attribute "Moonshot"
#define KEYRING_STORE_keyring_store_version "1.0"
#define KEYRING_STORE_item_type GNOME_KEYRING_ITEM_GENERIC_SECRET
static void keyring_store_real_add_card (IIdentityCardStore* base, IdCard* card);
void keyring_store_store_id_cards (KeyringStore* self);
static IdCard* keyring_store_real_update_card (IIdentityCardStore* base, IdCard* card);
const char* id_card_get_display_name (IdCard* self);
static gboolean keyring_store_real_remove_card (IIdentityCardStore* base, IdCard* card);
static IIdentityCardStoreStoreType keyring_store_real_get_store_type (IIdentityCardStore* base);
static GeeLinkedList* keyring_store_real_get_card_list (IIdentityCardStore* base);
static void keyring_store_clear_keyring (KeyringStore* self);
static void _g_list_free_gnome_keyring_found_free (GList* self);
static void keyring_store_load_id_cards (KeyringStore* self);
IdCard* id_card_new (void);
IdCard* id_card_construct (GType object_type);
void id_card_set_issuer (IdCard* self, const char* value);
void id_card_set_username (IdCard* self, const char* value);
void id_card_set_display_name (IdCard* self, const char* value);
void id_card_set_services (IdCard* self, char** value, int value_length1);
GType trust_anchor_get_type (void) G_GNUC_CONST;
TrustAnchor* id_card_get_trust_anchor (IdCard* self);
void trust_anchor_set_ca_cert (TrustAnchor* self, const char* value);
void trust_anchor_set_server_cert (TrustAnchor* self, const char* value);
void trust_anchor_set_subject (TrustAnchor* self, const char* value);
void trust_anchor_set_subject_alt (TrustAnchor* self, const char* value);
GType rule_get_type (void) G_GNUC_CONST;
Rule* rule_dup (const Rule* self);
void rule_free (Rule* self);
void rule_copy (const Rule* self, Rule* dest);
void rule_destroy (Rule* self);
void id_card_set_rules (IdCard* self, Rule* value, int value_length1);
static void _vala_Rule_array_free (Rule* array, gint array_length);
void id_card_set_store_password (IdCard* self, gboolean value);
gboolean id_card_get_store_password (IdCard* self);
void id_card_set_password (IdCard* self, const char* value);
Rule* id_card_get_rules (IdCard* self, int* result_length1);
static Rule* _vala_array_dup6 (Rule* self, int length);
char** id_card_get_services (IdCard* self, int* result_length1);
static char** _vala_array_dup7 (char** self, int length);
const char* id_card_get_issuer (IdCard* self);
const char* id_card_get_username (IdCard* self);
const char* trust_anchor_get_ca_cert (TrustAnchor* self);
const char* trust_anchor_get_server_cert (TrustAnchor* self);
const char* trust_anchor_get_subject (TrustAnchor* self);
const char* trust_anchor_get_subject_alt (TrustAnchor* self);
const char* id_card_get_password (IdCard* self);
KeyringStore* keyring_store_new (void);
KeyringStore* keyring_store_construct (GType object_type);
static void keyring_store_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 41 "moonshot-keyring-store.vala"
static void keyring_store_real_add_card (IIdentityCardStore* base, IdCard* card) {
#line 196 "moonshot-keyring-store.c"
	KeyringStore * self;
	self = (KeyringStore*) base;
#line 41 "moonshot-keyring-store.vala"
	g_return_if_fail (card != NULL);
#line 42 "moonshot-keyring-store.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) self->priv->id_card_list, card);
#line 43 "moonshot-keyring-store.vala"
	keyring_store_store_id_cards (self);
#line 205 "moonshot-keyring-store.c"
}


#line 46 "moonshot-keyring-store.vala"
static IdCard* keyring_store_real_update_card (IIdentityCardStore* base, IdCard* card) {
#line 211 "moonshot-keyring-store.c"
	KeyringStore * self;
	IdCard* result = NULL;
	self = (KeyringStore*) base;
#line 46 "moonshot-keyring-store.vala"
	g_return_val_if_fail (card != NULL, NULL);
#line 47 "moonshot-keyring-store.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) self->priv->id_card_list, card);
#line 48 "moonshot-keyring-store.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) self->priv->id_card_list, card);
#line 49 "moonshot-keyring-store.vala"
	keyring_store_store_id_cards (self);
#line 223 "moonshot-keyring-store.c"
	{
		GeeIterator* _idcard_it;
#line 50 "moonshot-keyring-store.vala"
		_idcard_it = gee_abstract_collection_iterator ((GeeAbstractCollection*) self->priv->id_card_list);
#line 50 "moonshot-keyring-store.vala"
		while (TRUE) {
#line 230 "moonshot-keyring-store.c"
			IdCard* idcard;
#line 50 "moonshot-keyring-store.vala"
			if (!gee_iterator_next (_idcard_it)) {
#line 50 "moonshot-keyring-store.vala"
				break;
#line 236 "moonshot-keyring-store.c"
			}
#line 50 "moonshot-keyring-store.vala"
			idcard = (IdCard*) gee_iterator_get (_idcard_it);
#line 51 "moonshot-keyring-store.vala"
			if (_vala_strcmp0 (id_card_get_display_name (idcard), id_card_get_display_name (card)) == 0) {
#line 242 "moonshot-keyring-store.c"
				result = idcard;
				_g_object_unref0 (_idcard_it);
#line 52 "moonshot-keyring-store.vala"
				return result;
#line 247 "moonshot-keyring-store.c"
			}
			_g_object_unref0 (idcard);
		}
		_g_object_unref0 (_idcard_it);
	}
	result = NULL;
#line 53 "moonshot-keyring-store.vala"
	return result;
#line 256 "moonshot-keyring-store.c"
}


#line 56 "moonshot-keyring-store.vala"
static gboolean keyring_store_real_remove_card (IIdentityCardStore* base, IdCard* card) {
#line 262 "moonshot-keyring-store.c"
	KeyringStore * self;
	gboolean result = FALSE;
	gboolean retval;
	self = (KeyringStore*) base;
#line 56 "moonshot-keyring-store.vala"
	g_return_val_if_fail (card != NULL, FALSE);
#line 57 "moonshot-keyring-store.vala"
	retval = gee_abstract_collection_remove ((GeeAbstractCollection*) self->priv->id_card_list, card);
#line 58 "moonshot-keyring-store.vala"
	if (retval) {
#line 59 "moonshot-keyring-store.vala"
		keyring_store_store_id_cards (self);
#line 275 "moonshot-keyring-store.c"
	}
	result = retval;
#line 60 "moonshot-keyring-store.vala"
	return result;
#line 280 "moonshot-keyring-store.c"
}


#line 63 "moonshot-keyring-store.vala"
static IIdentityCardStoreStoreType keyring_store_real_get_store_type (IIdentityCardStore* base) {
#line 286 "moonshot-keyring-store.c"
	KeyringStore * self;
	IIdentityCardStoreStoreType result = 0;
	self = (KeyringStore*) base;
	result = IIDENTITY_CARD_STORE_STORE_TYPE_KEYRING;
#line 64 "moonshot-keyring-store.vala"
	return result;
#line 293 "moonshot-keyring-store.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 67 "moonshot-keyring-store.vala"
static GeeLinkedList* keyring_store_real_get_card_list (IIdentityCardStore* base) {
#line 304 "moonshot-keyring-store.c"
	KeyringStore * self;
	GeeLinkedList* result = NULL;
	self = (KeyringStore*) base;
	result = _g_object_ref0 (self->priv->id_card_list);
#line 68 "moonshot-keyring-store.vala"
	return result;
#line 311 "moonshot-keyring-store.c"
}


static void _g_list_free_gnome_keyring_found_free (GList* self) {
	g_list_foreach (self, (GFunc) gnome_keyring_found_free, NULL);
	g_list_free (self);
}


#line 72 "moonshot-keyring-store.vala"
static void keyring_store_clear_keyring (KeyringStore* self) {
#line 323 "moonshot-keyring-store.c"
	GnomeKeyringAttributeList* match;
	GList* items;
	GList* _tmp0_ = NULL;
	GList* _tmp1_;
#line 72 "moonshot-keyring-store.vala"
	g_return_if_fail (self != NULL);
#line 73 "moonshot-keyring-store.vala"
	match = gnome_keyring_attribute_list_new ();
#line 74 "moonshot-keyring-store.vala"
	gnome_keyring_attribute_list_append_string (match, KEYRING_STORE_keyring_store_attribute, KEYRING_STORE_keyring_store_version);
#line 334 "moonshot-keyring-store.c"
	items = NULL;
#line 76 "moonshot-keyring-store.vala"
	gnome_keyring_find_items_sync (KEYRING_STORE_item_type, match, &_tmp0_);
#line 76 "moonshot-keyring-store.vala"
	items = (_tmp1_ = _tmp0_, __g_list_free_gnome_keyring_found_free0 (items), _tmp1_);
#line 340 "moonshot-keyring-store.c"
	{
		GList* entry_collection;
		GList* entry_it;
#line 77 "moonshot-keyring-store.vala"
		entry_collection = items;
#line 346 "moonshot-keyring-store.c"
		for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
			GnomeKeyringFound* entry;
#line 77 "moonshot-keyring-store.vala"
			entry = (GnomeKeyringFound*) entry_it->data;
#line 351 "moonshot-keyring-store.c"
			{
				GnomeKeyringResult _result_;
#line 78 "moonshot-keyring-store.vala"
				_result_ = gnome_keyring_item_delete_sync (NULL, (guint32) entry->item_id);
#line 79 "moonshot-keyring-store.vala"
				if (_result_ != GNOME_KEYRING_RESULT_OK) {
#line 80 "moonshot-keyring-store.vala"
					fprintf (stdout, "GnomeKeyring.item_delete_sync() failed. result: %d", (gint) _result_);
#line 360 "moonshot-keyring-store.c"
				}
			}
		}
	}
	__g_list_free_gnome_keyring_found_free0 (items);
	_gnome_keyring_attribute_list_free0 (match);
}


#line 1051 "glib-2.0.vapi"
static char* string_strip (const char* self) {
#line 372 "moonshot-keyring-store.c"
	char* result = NULL;
	char* _result_;
#line 1051 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1052 "glib-2.0.vapi"
	_result_ = g_strdup (self);
#line 1053 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 381 "moonshot-keyring-store.c"
	result = _result_;
#line 1054 "glib-2.0.vapi"
	return result;
#line 385 "moonshot-keyring-store.c"
}


static void _vala_Rule_array_free (Rule* array, gint array_length) {
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			rule_destroy (&array[i]);
		}
	}
	g_free (array);
}


#line 85 "moonshot-keyring-store.vala"
static void keyring_store_load_id_cards (KeyringStore* self) {
#line 402 "moonshot-keyring-store.c"
	GnomeKeyringAttributeList* match;
	GList* items;
	GList* _tmp0_ = NULL;
	GList* _tmp1_;
#line 85 "moonshot-keyring-store.vala"
	g_return_if_fail (self != NULL);
#line 86 "moonshot-keyring-store.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) self->priv->id_card_list);
#line 88 "moonshot-keyring-store.vala"
	match = gnome_keyring_attribute_list_new ();
#line 89 "moonshot-keyring-store.vala"
	gnome_keyring_attribute_list_append_string (match, KEYRING_STORE_keyring_store_attribute, KEYRING_STORE_keyring_store_version);
#line 415 "moonshot-keyring-store.c"
	items = NULL;
#line 91 "moonshot-keyring-store.vala"
	gnome_keyring_find_items_sync (KEYRING_STORE_item_type, match, &_tmp0_);
#line 91 "moonshot-keyring-store.vala"
	items = (_tmp1_ = _tmp0_, __g_list_free_gnome_keyring_found_free0 (items), _tmp1_);
#line 421 "moonshot-keyring-store.c"
	{
		GList* entry_collection;
		GList* entry_it;
#line 92 "moonshot-keyring-store.vala"
		entry_collection = items;
#line 427 "moonshot-keyring-store.c"
		for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
			GnomeKeyringFound* entry;
#line 92 "moonshot-keyring-store.vala"
			entry = (GnomeKeyringFound*) entry_it->data;
#line 432 "moonshot-keyring-store.c"
			{
				IdCard* id_card;
				gint i = 0;
				gint rules_patterns_index;
				gint rules_always_confirm_index;
				char* store_password;
				gboolean _tmp8_ = FALSE;
#line 93 "moonshot-keyring-store.vala"
				id_card = id_card_new ();
#line 95 "moonshot-keyring-store.vala"
				rules_patterns_index = -1;
#line 96 "moonshot-keyring-store.vala"
				rules_always_confirm_index = -1;
#line 97 "moonshot-keyring-store.vala"
				store_password = NULL;
#line 448 "moonshot-keyring-store.c"
				{
					gboolean _tmp2_;
#line 98 "moonshot-keyring-store.vala"
					i = 0;
#line 98 "moonshot-keyring-store.vala"
					_tmp2_ = TRUE;
#line 98 "moonshot-keyring-store.vala"
					while (TRUE) {
#line 457 "moonshot-keyring-store.c"
						GnomeKeyringAttribute attribute;
						char* value;
#line 98 "moonshot-keyring-store.vala"
						if (!_tmp2_) {
#line 98 "moonshot-keyring-store.vala"
							i++;
#line 464 "moonshot-keyring-store.c"
						}
#line 98 "moonshot-keyring-store.vala"
						_tmp2_ = FALSE;
#line 98 "moonshot-keyring-store.vala"
						if (!(i < entry->attributes->len)) {
#line 98 "moonshot-keyring-store.vala"
							break;
#line 472 "moonshot-keyring-store.c"
						}
#line 99 "moonshot-keyring-store.vala"
						attribute = ((GnomeKeyringAttribute*) entry->attributes->data)[i];
#line 100 "moonshot-keyring-store.vala"
						value = g_strdup (attribute.value.string);
#line 101 "moonshot-keyring-store.vala"
						if (_vala_strcmp0 (attribute.name, "Issuer") == 0) {
#line 102 "moonshot-keyring-store.vala"
							id_card_set_issuer (id_card, value);
#line 482 "moonshot-keyring-store.c"
						} else {
#line 103 "moonshot-keyring-store.vala"
							if (_vala_strcmp0 (attribute.name, "Username") == 0) {
#line 104 "moonshot-keyring-store.vala"
								id_card_set_username (id_card, value);
#line 488 "moonshot-keyring-store.c"
							} else {
#line 105 "moonshot-keyring-store.vala"
								if (_vala_strcmp0 (attribute.name, "DisplayName") == 0) {
#line 106 "moonshot-keyring-store.vala"
									id_card_set_display_name (id_card, value);
#line 494 "moonshot-keyring-store.c"
								} else {
#line 107 "moonshot-keyring-store.vala"
									if (_vala_strcmp0 (attribute.name, "Services") == 0) {
#line 498 "moonshot-keyring-store.c"
										char** _tmp3_;
										char** _tmp4_;
										gint _tmp4__length1;
										char** _tmp5_;
#line 108 "moonshot-keyring-store.vala"
										_tmp5_ = (_tmp4_ = _tmp3_ = g_strsplit (value, ";", 0), _tmp4__length1 = _vala_array_length (_tmp3_), _tmp4_);
#line 108 "moonshot-keyring-store.vala"
										id_card_set_services (id_card, _tmp5_, _vala_array_length (_tmp3_));
#line 507 "moonshot-keyring-store.c"
										_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
									} else {
#line 109 "moonshot-keyring-store.vala"
										if (_vala_strcmp0 (attribute.name, "Rules-Pattern") == 0) {
#line 110 "moonshot-keyring-store.vala"
											rules_patterns_index = i;
#line 514 "moonshot-keyring-store.c"
										} else {
#line 111 "moonshot-keyring-store.vala"
											if (_vala_strcmp0 (attribute.name, "Rules-AlwaysConfirm") == 0) {
#line 112 "moonshot-keyring-store.vala"
												rules_always_confirm_index = i;
#line 520 "moonshot-keyring-store.c"
											} else {
#line 113 "moonshot-keyring-store.vala"
												if (_vala_strcmp0 (attribute.name, "CA-Cert") == 0) {
#line 524 "moonshot-keyring-store.c"
													char* _tmp6_;
#line 114 "moonshot-keyring-store.vala"
													trust_anchor_set_ca_cert (id_card_get_trust_anchor (id_card), _tmp6_ = string_strip (value));
#line 528 "moonshot-keyring-store.c"
													_g_free0 (_tmp6_);
												} else {
#line 115 "moonshot-keyring-store.vala"
													if (_vala_strcmp0 (attribute.name, "Server-Cert") == 0) {
#line 116 "moonshot-keyring-store.vala"
														trust_anchor_set_server_cert (id_card_get_trust_anchor (id_card), value);
#line 535 "moonshot-keyring-store.c"
													} else {
#line 117 "moonshot-keyring-store.vala"
														if (_vala_strcmp0 (attribute.name, "Subject") == 0) {
#line 118 "moonshot-keyring-store.vala"
															trust_anchor_set_subject (id_card_get_trust_anchor (id_card), value);
#line 541 "moonshot-keyring-store.c"
														} else {
#line 119 "moonshot-keyring-store.vala"
															if (_vala_strcmp0 (attribute.name, "Subject-Alt") == 0) {
#line 120 "moonshot-keyring-store.vala"
																trust_anchor_set_subject_alt (id_card_get_trust_anchor (id_card), value);
#line 547 "moonshot-keyring-store.c"
															} else {
#line 121 "moonshot-keyring-store.vala"
																if (_vala_strcmp0 (attribute.name, "StorePassword") == 0) {
#line 551 "moonshot-keyring-store.c"
																	char* _tmp7_;
#line 122 "moonshot-keyring-store.vala"
																	store_password = (_tmp7_ = g_strdup (value), _g_free0 (store_password), _tmp7_);
#line 555 "moonshot-keyring-store.c"
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
						_g_free0 (value);
					}
				}
#line 125 "moonshot-keyring-store.vala"
				if (rules_always_confirm_index != (-1)) {
#line 125 "moonshot-keyring-store.vala"
					_tmp8_ = rules_patterns_index != (-1);
#line 574 "moonshot-keyring-store.c"
				} else {
#line 125 "moonshot-keyring-store.vala"
					_tmp8_ = FALSE;
#line 578 "moonshot-keyring-store.c"
				}
#line 125 "moonshot-keyring-store.vala"
				if (_tmp8_) {
#line 582 "moonshot-keyring-store.c"
					char* rules_patterns_all;
					char* rules_always_confirm_all;
					gint rules_always_confirm_length1;
					gint _rules_always_confirm_size_;
					char** _tmp10_;
					char** _tmp9_;
					char** rules_always_confirm;
					gint rules_patterns_length1;
					gint _rules_patterns_size_;
					char** _tmp12_;
					char** _tmp11_;
					char** rules_patterns;
#line 126 "moonshot-keyring-store.vala"
					rules_patterns_all = g_strdup (((GnomeKeyringAttribute*) entry->attributes->data)[rules_patterns_index].value.string);
#line 127 "moonshot-keyring-store.vala"
					rules_always_confirm_all = g_strdup (((GnomeKeyringAttribute*) entry->attributes->data)[rules_always_confirm_index].value.string);
#line 599 "moonshot-keyring-store.c"
					rules_always_confirm = (_tmp10_ = _tmp9_ = g_strsplit (rules_always_confirm_all, ";", 0), rules_always_confirm_length1 = _vala_array_length (_tmp9_), _rules_always_confirm_size_ = rules_always_confirm_length1, _tmp10_);
					rules_patterns = (_tmp12_ = _tmp11_ = g_strsplit (rules_patterns_all, ";", 0), rules_patterns_length1 = _vala_array_length (_tmp11_), _rules_patterns_size_ = rules_patterns_length1, _tmp12_);
#line 130 "moonshot-keyring-store.vala"
					if (rules_patterns_length1 == rules_always_confirm_length1) {
#line 604 "moonshot-keyring-store.c"
						gint rules_length1;
						gint _rules_size_;
						Rule* _tmp13_;
						Rule* rules;
						Rule* _tmp17_;
						rules = (_tmp13_ = g_new0 (Rule, rules_patterns_length1), rules_length1 = rules_patterns_length1, _rules_size_ = rules_length1, _tmp13_);
						{
							gint j;
#line 132 "moonshot-keyring-store.vala"
							j = 0;
#line 615 "moonshot-keyring-store.c"
							{
								gboolean _tmp14_;
#line 132 "moonshot-keyring-store.vala"
								_tmp14_ = TRUE;
#line 132 "moonshot-keyring-store.vala"
								while (TRUE) {
#line 622 "moonshot-keyring-store.c"
									char* _tmp15_;
									char* _tmp16_;
#line 132 "moonshot-keyring-store.vala"
									if (!_tmp14_) {
#line 132 "moonshot-keyring-store.vala"
										j++;
#line 629 "moonshot-keyring-store.c"
									}
#line 132 "moonshot-keyring-store.vala"
									_tmp14_ = FALSE;
#line 132 "moonshot-keyring-store.vala"
									if (!(j < rules_patterns_length1)) {
#line 132 "moonshot-keyring-store.vala"
										break;
#line 637 "moonshot-keyring-store.c"
									}
#line 133 "moonshot-keyring-store.vala"
									rules[j].pattern = (_tmp15_ = g_strdup (rules_patterns[j]), _g_free0 (rules[j].pattern), _tmp15_);
#line 134 "moonshot-keyring-store.vala"
									rules[j].always_confirm = (_tmp16_ = g_strdup (rules_always_confirm[j]), _g_free0 (rules[j].always_confirm), _tmp16_);
#line 643 "moonshot-keyring-store.c"
								}
							}
						}
#line 136 "moonshot-keyring-store.vala"
						_tmp17_ = rules;
#line 136 "moonshot-keyring-store.vala"
						id_card_set_rules (id_card, _tmp17_, rules_length1);
#line 651 "moonshot-keyring-store.c"
						rules = (_vala_Rule_array_free (rules, rules_length1), NULL);
					}
					rules_patterns = (_vala_array_free (rules_patterns, rules_patterns_length1, (GDestroyNotify) g_free), NULL);
					rules_always_confirm = (_vala_array_free (rules_always_confirm, rules_always_confirm_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (rules_always_confirm_all);
					_g_free0 (rules_patterns_all);
				}
#line 140 "moonshot-keyring-store.vala"
				if (store_password != NULL) {
#line 141 "moonshot-keyring-store.vala"
					id_card_set_store_password (id_card, _vala_strcmp0 (store_password, "yes") == 0);
#line 663 "moonshot-keyring-store.c"
				} else {
					gboolean _tmp18_ = FALSE;
#line 143 "moonshot-keyring-store.vala"
					if (entry->secret != NULL) {
#line 143 "moonshot-keyring-store.vala"
						_tmp18_ = _vala_strcmp0 (entry->secret, "") != 0;
#line 670 "moonshot-keyring-store.c"
					} else {
#line 143 "moonshot-keyring-store.vala"
						_tmp18_ = FALSE;
#line 674 "moonshot-keyring-store.c"
					}
#line 143 "moonshot-keyring-store.vala"
					id_card_set_store_password (id_card, _tmp18_);
#line 678 "moonshot-keyring-store.c"
				}
#line 145 "moonshot-keyring-store.vala"
				if (id_card_get_store_password (id_card)) {
#line 146 "moonshot-keyring-store.vala"
					id_card_set_password (id_card, entry->secret);
#line 684 "moonshot-keyring-store.c"
				} else {
#line 148 "moonshot-keyring-store.vala"
					id_card_set_password (id_card, NULL);
#line 688 "moonshot-keyring-store.c"
				}
#line 149 "moonshot-keyring-store.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) self->priv->id_card_list, id_card);
#line 692 "moonshot-keyring-store.c"
				_g_free0 (store_password);
				_g_object_unref0 (id_card);
			}
		}
	}
	__g_list_free_gnome_keyring_found_free0 (items);
	_gnome_keyring_attribute_list_free0 (match);
}


static Rule* _vala_array_dup6 (Rule* self, int length) {
	Rule* result;
	int i;
	Rule _tmp0_ = {0};
	result = g_new0 (Rule, length);
	for (i = 0; i < length; i++) {
		result[i] = (rule_copy (&self[i], &_tmp0_), _tmp0_);
	}
	return result;
}


static char** _vala_array_dup7 (char** self, int length) {
	char** result;
	int i;
	result = g_new0 (char*, length + 1);
	for (i = 0; i < length; i++) {
		result[i] = g_strdup (self[i]);
	}
	return result;
}


#line 153 "moonshot-keyring-store.vala"
void keyring_store_store_id_cards (KeyringStore* self) {
#line 153 "moonshot-keyring-store.vala"
	g_return_if_fail (self != NULL);
#line 154 "moonshot-keyring-store.vala"
	keyring_store_clear_keyring (self);
#line 732 "moonshot-keyring-store.c"
	{
		GeeIterator* _id_card_it;
#line 155 "moonshot-keyring-store.vala"
		_id_card_it = gee_abstract_collection_iterator ((GeeAbstractCollection*) self->priv->id_card_list);
#line 155 "moonshot-keyring-store.vala"
		while (TRUE) {
#line 739 "moonshot-keyring-store.c"
			IdCard* id_card;
			gint rules_length1;
			gint _rules_size_;
			Rule* _tmp2_;
			gint _tmp0_;
			Rule* _tmp1_;
			Rule* rules;
			gint services_array_length1;
			gint _services_array_size_;
			char** _tmp5_;
			gint _tmp3_;
			char** _tmp4_;
			char** services_array;
			gint rules_patterns_length1;
			gint _rules_patterns_size_;
			char** _tmp6_;
			char** rules_patterns;
			gint rules_always_conf_length1;
			gint _rules_always_conf_size_;
			char** _tmp7_;
			char** rules_always_conf;
			char* patterns;
			char* always_conf;
			char* services;
			GnomeKeyringAttributeList* attributes;
			guint32 item_id = 0U;
			const char* _tmp11_;
			const char* _tmp12_;
			GnomeKeyringResult _result_;
#line 155 "moonshot-keyring-store.vala"
			if (!gee_iterator_next (_id_card_it)) {
#line 155 "moonshot-keyring-store.vala"
				break;
#line 773 "moonshot-keyring-store.c"
			}
#line 155 "moonshot-keyring-store.vala"
			id_card = (IdCard*) gee_iterator_get (_id_card_it);
#line 777 "moonshot-keyring-store.c"
			rules = (_tmp2_ = (_tmp1_ = id_card_get_rules (id_card, &_tmp0_), (_tmp1_ == NULL) ? ((gpointer) _tmp1_) : _vala_array_dup6 (_tmp1_, _tmp0_)), rules_length1 = _tmp0_, _rules_size_ = rules_length1, _tmp2_);
			services_array = (_tmp5_ = (_tmp4_ = id_card_get_services (id_card, &_tmp3_), (_tmp4_ == NULL) ? ((gpointer) _tmp4_) : _vala_array_dup7 (_tmp4_, _tmp3_)), services_array_length1 = _tmp3_, _services_array_size_ = services_array_length1, _tmp5_);
			rules_patterns = (_tmp6_ = g_new0 (char*, rules_length1 + 1), rules_patterns_length1 = rules_length1, _rules_patterns_size_ = rules_patterns_length1, _tmp6_);
			rules_always_conf = (_tmp7_ = g_new0 (char*, rules_length1 + 1), rules_always_conf_length1 = rules_length1, _rules_always_conf_size_ = rules_always_conf_length1, _tmp7_);
			{
				gint i;
#line 162 "moonshot-keyring-store.vala"
				i = 0;
#line 786 "moonshot-keyring-store.c"
				{
					gboolean _tmp8_;
#line 162 "moonshot-keyring-store.vala"
					_tmp8_ = TRUE;
#line 162 "moonshot-keyring-store.vala"
					while (TRUE) {
#line 793 "moonshot-keyring-store.c"
						char* _tmp9_;
						char* _tmp10_;
#line 162 "moonshot-keyring-store.vala"
						if (!_tmp8_) {
#line 162 "moonshot-keyring-store.vala"
							i++;
#line 800 "moonshot-keyring-store.c"
						}
#line 162 "moonshot-keyring-store.vala"
						_tmp8_ = FALSE;
#line 162 "moonshot-keyring-store.vala"
						if (!(i < rules_length1)) {
#line 162 "moonshot-keyring-store.vala"
							break;
#line 808 "moonshot-keyring-store.c"
						}
#line 163 "moonshot-keyring-store.vala"
						rules_patterns[i] = (_tmp9_ = g_strdup (rules[i].pattern), _g_free0 (rules_patterns[i]), _tmp9_);
#line 164 "moonshot-keyring-store.vala"
						rules_always_conf[i] = (_tmp10_ = g_strdup (rules[i].always_confirm), _g_free0 (rules_always_conf[i]), _tmp10_);
#line 814 "moonshot-keyring-store.c"
					}
				}
			}
#line 166 "moonshot-keyring-store.vala"
			patterns = g_strjoinv (";", rules_patterns);
#line 167 "moonshot-keyring-store.vala"
			always_conf = g_strjoinv (";", rules_always_conf);
#line 168 "moonshot-keyring-store.vala"
			services = g_strjoinv (";", services_array);
#line 169 "moonshot-keyring-store.vala"
			attributes = gnome_keyring_attribute_list_new ();
#line 171 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, KEYRING_STORE_keyring_store_attribute, KEYRING_STORE_keyring_store_version);
#line 172 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "Issuer", id_card_get_issuer (id_card));
#line 173 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "Username", id_card_get_username (id_card));
#line 174 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "DisplayName", id_card_get_display_name (id_card));
#line 175 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "Services", services);
#line 176 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "Rules-Pattern", patterns);
#line 177 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "Rules-AlwaysConfirm", always_conf);
#line 178 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "CA-Cert", trust_anchor_get_ca_cert (id_card_get_trust_anchor (id_card)));
#line 179 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "Server-Cert", trust_anchor_get_server_cert (id_card_get_trust_anchor (id_card)));
#line 180 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "Subject", trust_anchor_get_subject (id_card_get_trust_anchor (id_card)));
#line 181 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "Subject-Alt", trust_anchor_get_subject_alt (id_card_get_trust_anchor (id_card)));
#line 848 "moonshot-keyring-store.c"
			_tmp11_ = NULL;
#line 182 "moonshot-keyring-store.vala"
			if (id_card_get_store_password (id_card)) {
#line 182 "moonshot-keyring-store.vala"
				_tmp11_ = "yes";
#line 854 "moonshot-keyring-store.c"
			} else {
#line 182 "moonshot-keyring-store.vala"
				_tmp11_ = "no";
#line 858 "moonshot-keyring-store.c"
			}
#line 182 "moonshot-keyring-store.vala"
			gnome_keyring_attribute_list_append_string (attributes, "StorePassword", _tmp11_);
#line 862 "moonshot-keyring-store.c"
			_tmp12_ = NULL;
#line 186 "moonshot-keyring-store.vala"
			if (id_card_get_store_password (id_card)) {
#line 186 "moonshot-keyring-store.vala"
				_tmp12_ = id_card_get_password (id_card);
#line 868 "moonshot-keyring-store.c"
			} else {
#line 186 "moonshot-keyring-store.vala"
				_tmp12_ = "";
#line 872 "moonshot-keyring-store.c"
			}
#line 184 "moonshot-keyring-store.vala"
			_result_ = gnome_keyring_item_create_sync (NULL, KEYRING_STORE_item_type, id_card_get_display_name (id_card), attributes, _tmp12_, TRUE, &item_id);
#line 188 "moonshot-keyring-store.vala"
			if (_result_ != GNOME_KEYRING_RESULT_OK) {
#line 189 "moonshot-keyring-store.vala"
				fprintf (stdout, "GnomeKeyring.item_create_sync() failed. result: %d", (gint) _result_);
#line 880 "moonshot-keyring-store.c"
			}
			_gnome_keyring_attribute_list_free0 (attributes);
			_g_free0 (services);
			_g_free0 (always_conf);
			_g_free0 (patterns);
			rules_always_conf = (_vala_array_free (rules_always_conf, rules_always_conf_length1, (GDestroyNotify) g_free), NULL);
			rules_patterns = (_vala_array_free (rules_patterns, rules_patterns_length1, (GDestroyNotify) g_free), NULL);
			services_array = (_vala_array_free (services_array, services_array_length1, (GDestroyNotify) g_free), NULL);
			rules = (_vala_Rule_array_free (rules, rules_length1), NULL);
			_g_object_unref0 (id_card);
		}
		_g_object_unref0 (_id_card_it);
	}
#line 192 "moonshot-keyring-store.vala"
	keyring_store_load_id_cards (self);
#line 896 "moonshot-keyring-store.c"
}


#line 195 "moonshot-keyring-store.vala"
KeyringStore* keyring_store_construct (GType object_type) {
#line 902 "moonshot-keyring-store.c"
	KeyringStore * self = NULL;
	GeeLinkedList* _tmp0_;
#line 195 "moonshot-keyring-store.vala"
	self = (KeyringStore*) g_object_new (object_type, NULL);
#line 196 "moonshot-keyring-store.vala"
	self->priv->id_card_list = (_tmp0_ = gee_linked_list_new (TYPE_ID_CARD, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL), _g_object_unref0 (self->priv->id_card_list), _tmp0_);
#line 197 "moonshot-keyring-store.vala"
	keyring_store_load_id_cards (self);
#line 911 "moonshot-keyring-store.c"
	return self;
}


#line 195 "moonshot-keyring-store.vala"
KeyringStore* keyring_store_new (void) {
#line 195 "moonshot-keyring-store.vala"
	return keyring_store_construct (TYPE_KEYRING_STORE);
#line 920 "moonshot-keyring-store.c"
}


static void keyring_store_class_init (KeyringStoreClass * klass) {
	keyring_store_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (KeyringStorePrivate));
	G_OBJECT_CLASS (klass)->finalize = keyring_store_finalize;
}


static void keyring_store_iidentity_card_store_interface_init (IIdentityCardStoreIface * iface) {
	keyring_store_iidentity_card_store_parent_iface = g_type_interface_peek_parent (iface);
	iface->add_card = keyring_store_real_add_card;
	iface->update_card = keyring_store_real_update_card;
	iface->remove_card = keyring_store_real_remove_card;
	iface->get_store_type = keyring_store_real_get_store_type;
	iface->get_card_list = keyring_store_real_get_card_list;
}


static void keyring_store_instance_init (KeyringStore * self) {
	self->priv = KEYRING_STORE_GET_PRIVATE (self);
}


static void keyring_store_finalize (GObject* obj) {
	KeyringStore * self;
	self = KEYRING_STORE (obj);
	_g_object_unref0 (self->priv->id_card_list);
	G_OBJECT_CLASS (keyring_store_parent_class)->finalize (obj);
}


GType keyring_store_get_type (void) {
	static volatile gsize keyring_store_type_id__volatile = 0;
	if (g_once_init_enter (&keyring_store_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KeyringStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) keyring_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyringStore), 0, (GInstanceInitFunc) keyring_store_instance_init, NULL };
		static const GInterfaceInfo iidentity_card_store_info = { (GInterfaceInitFunc) keyring_store_iidentity_card_store_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType keyring_store_type_id;
		keyring_store_type_id = g_type_register_static (G_TYPE_OBJECT, "KeyringStore", &g_define_type_info, 0);
		g_type_add_interface_static (keyring_store_type_id, TYPE_IIDENTITY_CARD_STORE, &iidentity_card_store_info);
		g_once_init_leave (&keyring_store_type_id__volatile, keyring_store_type_id);
	}
	return keyring_store_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




