/* moonshot-utils.c generated by valac 0.10.4, the Vala compiler
 * generated from moonshot-utils.vala, do not modify */

/*
 * Copyright (c) 2011-2014, JANET(UK)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of JANET(UK) nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <stdio.h>


#define TYPE_ID_CARD (id_card_get_type ())
#define ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ID_CARD, IdCard))
#define ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ID_CARD, IdCardClass))
#define IS_ID_CARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ID_CARD))
#define IS_ID_CARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ID_CARD))
#define ID_CARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ID_CARD, IdCardClass))

typedef struct _IdCard IdCard;
typedef struct _IdCardClass IdCardClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))


extern gboolean gtk_available;
gboolean gtk_available = FALSE;

GdkPixbuf* find_icon_sized (const char* name, GtkIconSize icon_size);
GdkPixbuf* find_icon (const char* name, gint size);
GType id_card_get_type (void) G_GNUC_CONST;
GdkPixbuf* get_pixbuf (IdCard* id);
const char* GetUserName (void);
const char* GetFlatStoreUsersFilePath (void);
gboolean UserForcesFlatFileStore (void);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 36 "moonshot-utils.vala"
GdkPixbuf* find_icon_sized (const char* name, GtkIconSize icon_size) {
#line 78 "moonshot-utils.c"
	GdkPixbuf* result = NULL;
	gint width = 0;
	gint height = 0;
#line 36 "moonshot-utils.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 39 "moonshot-utils.vala"
	gtk_icon_size_lookup (icon_size, &width, &height);
#line 86 "moonshot-utils.c"
	result = find_icon (name, width);
#line 40 "moonshot-utils.vala"
	return result;
#line 90 "moonshot-utils.c"
}


#line 50 "moonshot-utils.vala"
GdkPixbuf* get_pixbuf (IdCard* id) {
#line 96 "moonshot-utils.c"
	GdkPixbuf* result = NULL;
#line 50 "moonshot-utils.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 100 "moonshot-utils.c"
	result = find_icon ("avatar-default", 48);
#line 52 "moonshot-utils.vala"
	return result;
#line 104 "moonshot-utils.c"
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


#line 55 "moonshot-utils.vala"
GdkPixbuf* find_icon (const char* name, gint size) {
#line 115 "moonshot-utils.c"
	GdkPixbuf* result = NULL;
	GError * _inner_error_ = NULL;
#line 55 "moonshot-utils.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 57 "moonshot-utils.vala"
	if (!gtk_available) {
#line 122 "moonshot-utils.c"
		result = NULL;
#line 58 "moonshot-utils.vala"
		return result;
#line 126 "moonshot-utils.c"
	}
	{
		GtkIconTheme* icon_theme;
		GdkPixbuf* _tmp0_;
#line 73 "moonshot-utils.vala"
		icon_theme = _g_object_ref0 (gtk_icon_theme_get_default ());
#line 74 "moonshot-utils.vala"
		_tmp0_ = gtk_icon_theme_load_icon (icon_theme, name, size, GTK_ICON_LOOKUP_FORCE_SIZE, &_inner_error_);
#line 135 "moonshot-utils.c"
		if (_inner_error_ != NULL) {
			_g_object_unref0 (icon_theme);
			goto __catch9_g_error;
		}
		result = _tmp0_;
		_g_object_unref0 (icon_theme);
#line 74 "moonshot-utils.vala"
		return result;
#line 144 "moonshot-utils.c"
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 79 "moonshot-utils.vala"
			fprintf (stdout, "Error loading icon '%s': %s\n", name, e->message);
#line 155 "moonshot-utils.c"
			result = NULL;
			_g_error_free0 (e);
#line 80 "moonshot-utils.vala"
			return result;
#line 160 "moonshot-utils.c"
		}
	}
	__finally9:
	{
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 2847 "glib-2.0.vapi"
static char* g_file_stream_read_line (FILE* self) {
#line 174 "moonshot-utils.c"
	char* result = NULL;
	gint c = 0;
	GString* ret;
#line 2847 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 2849 "glib-2.0.vapi"
	ret = NULL;
#line 2850 "glib-2.0.vapi"
	while (TRUE) {
#line 2850 "glib-2.0.vapi"
		if (!((c = fgetc (self)) != EOF)) {
#line 2850 "glib-2.0.vapi"
			break;
#line 188 "moonshot-utils.c"
		}
#line 2851 "glib-2.0.vapi"
		if (ret == NULL) {
#line 192 "moonshot-utils.c"
			GString* _tmp0_;
#line 2852 "glib-2.0.vapi"
			ret = (_tmp0_ = g_string_new (""), _g_string_free0 (ret), _tmp0_);
#line 196 "moonshot-utils.c"
		}
#line 2854 "glib-2.0.vapi"
		if (c == '\n') {
#line 2855 "glib-2.0.vapi"
			break;
#line 202 "moonshot-utils.c"
		}
#line 2857 "glib-2.0.vapi"
		g_string_append_c (ret, (gchar) c);
#line 206 "moonshot-utils.c"
	}
#line 2859 "glib-2.0.vapi"
	if (ret == NULL) {
#line 210 "moonshot-utils.c"
		result = NULL;
		_g_string_free0 (ret);
#line 2860 "glib-2.0.vapi"
		return result;
#line 215 "moonshot-utils.c"
	} else {
		result = g_strdup (ret->str);
		_g_string_free0 (ret);
#line 2862 "glib-2.0.vapi"
		return result;
#line 221 "moonshot-utils.c"
	}
	_g_string_free0 (ret);
}


#line 87 "moonshot-utils.vala"
gboolean UserForcesFlatFileStore (void) {
#line 229 "moonshot-utils.c"
	gboolean result = FALSE;
	char* username;
	char* flatstore_users_filename;
	FILE* flatstore_users;
	char* flatstore_username;
#line 89 "moonshot-utils.vala"
	username = g_strdup (GetUserName ());
#line 90 "moonshot-utils.vala"
	flatstore_users_filename = g_strdup (GetFlatStoreUsersFilePath ());
#line 91 "moonshot-utils.vala"
	flatstore_users = fopen (flatstore_users_filename, "r");
#line 92 "moonshot-utils.vala"
	if (flatstore_users == NULL) {
#line 243 "moonshot-utils.c"
		result = FALSE;
		_fclose0 (flatstore_users);
		_g_free0 (flatstore_users_filename);
		_g_free0 (username);
#line 93 "moonshot-utils.vala"
		return result;
#line 250 "moonshot-utils.c"
	}
#line 95 "moonshot-utils.vala"
	flatstore_username = NULL;
#line 96 "moonshot-utils.vala"
	while (TRUE) {
#line 256 "moonshot-utils.c"
		char* _tmp0_;
#line 96 "moonshot-utils.vala"
		if (!((flatstore_username = (_tmp0_ = g_file_stream_read_line (flatstore_users), _g_free0 (flatstore_username), _tmp0_)) != NULL)) {
#line 96 "moonshot-utils.vala"
			break;
#line 262 "moonshot-utils.c"
		}
#line 97 "moonshot-utils.vala"
		if (_vala_strcmp0 (username, flatstore_username) == 0) {
#line 266 "moonshot-utils.c"
			result = TRUE;
			_g_free0 (flatstore_username);
			_fclose0 (flatstore_users);
			_g_free0 (flatstore_users_filename);
			_g_free0 (username);
#line 98 "moonshot-utils.vala"
			return result;
#line 274 "moonshot-utils.c"
		}
	}
	result = FALSE;
	_g_free0 (flatstore_username);
	_fclose0 (flatstore_users);
	_g_free0 (flatstore_users_filename);
	_g_free0 (username);
#line 101 "moonshot-utils.vala"
	return result;
#line 284 "moonshot-utils.c"
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




